## This client library is not design to be use directly, instead use ours [Pinterest Python SDK](https://github.com/pinterest/pinterest-python-sdk)

# Pinterest_Generated_Client
Pinterest's REST API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 5.14.0
- Package version: 0.1.10
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://developers.pinterest.com/](https://developers.pinterest.com/)

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

#### Using HTTPS

```sh
pip install git+https://github.com/pinterest/pinterest-python-generated-api-client.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/pinterest/pinterest-python-generated-api-client.git`)

#### Using SSH

```sh
pip install git+ssh://github.com/pinterest/pinterest-python-generated-api-client.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/pinterest/pinterest-python-generated-api-client.git`)

Then import the package:
```python
import openapi_generated.pinterest_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_generated.pinterest_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import openapi_generated.pinterest_client
from pprint import pprint
from openapi_generated.pinterest_client.api import ad_accounts_api
from openapi_generated.pinterest_client.model.ad_account import AdAccount
from openapi_generated.pinterest_client.model.ad_account_analytics_response import AdAccountAnalyticsResponse
from openapi_generated.pinterest_client.model.ad_account_create_request import AdAccountCreateRequest
from openapi_generated.pinterest_client.model.ads_analytics_create_async_request import AdsAnalyticsCreateAsyncRequest
from openapi_generated.pinterest_client.model.ads_analytics_create_async_response import AdsAnalyticsCreateAsyncResponse
from openapi_generated.pinterest_client.model.ads_analytics_get_async_response import AdsAnalyticsGetAsyncResponse
from openapi_generated.pinterest_client.model.ads_analytics_targeting_type import AdsAnalyticsTargetingType
from openapi_generated.pinterest_client.model.conversion_report_attribution_type import ConversionReportAttributionType
from openapi_generated.pinterest_client.model.create_mmm_report_request import CreateMMMReportRequest
from openapi_generated.pinterest_client.model.create_mmm_report_response import CreateMMMReportResponse
from openapi_generated.pinterest_client.model.error import Error
from openapi_generated.pinterest_client.model.get_mmm_report_response import GetMMMReportResponse
from openapi_generated.pinterest_client.model.granularity import Granularity
from openapi_generated.pinterest_client.model.metrics_response import MetricsResponse
from openapi_generated.pinterest_client.model.paginated import Paginated
from openapi_generated.pinterest_client.model.template_response import TemplateResponse
# Defining the host is optional and defaults to https://api.pinterest.com/v5
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_generated.pinterest_client.Configuration(
    host = "https://api.pinterest.com/v5"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure OAuth2 access token for authorization: pinterest_oauth2
configuration = openapi_generated.pinterest_client.Configuration(
    host = "https://api.pinterest.com/v5"
)
configuration.access_token = 'YOUR_ACCESS_TOKEN'


# Enter a context with an instance of the API client
with openapi_generated.pinterest_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ad_accounts_api.AdAccountsApi(api_client)
    ad_account_id = "4" # str | Unique identifier of an ad account.
    start_date = dateutil_parser('1970-01-01').date() # date | Metric report start date (UTC). Format: YYYY-MM-DD. Cannot be more than 90 days back from today.
    end_date = dateutil_parser('1970-01-01').date() # date | Metric report end date (UTC). Format: YYYY-MM-DD. Cannot be more than 90 days past start_date.
    columns = [
        "TOTAL_CONVERSIONS",
    ] # [str] | Columns to retrieve, encoded as a comma-separated string. **NOTE**: Any metrics defined as MICRO_DOLLARS returns a value based on the advertiser profile's currency field. For USD,($1/1,000,000, or $0.000001 - one one-ten-thousandth of a cent). it's microdollars. Otherwise, it's in microunits of the advertiser's currency.<br/>For example, if the advertiser's currency is GBP (British pound sterling), all MICRO_DOLLARS fields will be in GBP microunits (1/1,000,000 British pound).<br/>If a column has no value, it may not be returned
    granularity = Granularity("DAY") # Granularity | TOTAL - metrics are aggregated over the specified date range.<br> DAY - metrics are broken down daily.<br> HOUR - metrics are broken down hourly.<br>WEEKLY - metrics are broken down weekly.<br>MONTHLY - metrics are broken down monthly
    click_window_days = 1 # int | Number of days to use as the conversion attribution window for a pin click action. Applies to Pinterest Tag conversion metrics. Prior conversion tags use their defined attribution windows. If not specified, defaults to `30` days. (optional) (default to 30)
    engagement_window_days = 30 # int | Number of days to use as the conversion attribution window for an engagement action. Engagements include saves, closeups, link clicks, and carousel card swipes. Applies to Pinterest Tag conversion metrics. Prior conversion tags use their defined attribution windows. If not specified, defaults to `30` days. (optional) (default to 30)
    view_window_days = 1 # int | Number of days to use as the conversion attribution window for a view action. Applies to Pinterest Tag conversion metrics. Prior conversion tags use their defined attribution windows. If not specified, defaults to `1` day. (optional) (default to 1)
    conversion_report_time = "TIME_OF_AD_ACTION" # str | The date by which the conversion metrics returned from this endpoint will be reported. There are two dates associated with a conversion event: the date that the user interacted with the ad, and the date that the user completed a conversion event. (optional) (default to "TIME_OF_AD_ACTION")

    try:
        # Get ad account analytics
        api_response = api_instance.ad_account_analytics(ad_account_id, start_date, end_date, columns, granularity, click_window_days=click_window_days, engagement_window_days=engagement_window_days, view_window_days=view_window_days, conversion_report_time=conversion_report_time)
        pprint(api_response)
    except openapi_generated.pinterest_client.ApiException as e:
        print("Exception when calling AdAccountsApi->ad_account_analytics: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.pinterest.com/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdAccountsApi* | [**ad_account_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#ad_account_analytics) | **GET** /ad_accounts/{ad_account_id}/analytics | Get ad account analytics
*AdAccountsApi* | [**ad_account_targeting_analytics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#ad_account_targeting_analytics_get) | **GET** /ad_accounts/{ad_account_id}/targeting_analytics | Get targeting analytics for an ad account
*AdAccountsApi* | [**ad_accounts_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#ad_accounts_create) | **POST** /ad_accounts | Create ad account
*AdAccountsApi* | [**ad_accounts_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#ad_accounts_get) | **GET** /ad_accounts/{ad_account_id} | Get ad account
*AdAccountsApi* | [**ad_accounts_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#ad_accounts_list) | **GET** /ad_accounts | List ad accounts
*AdAccountsApi* | [**analytics_create_mmm_report**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#analytics_create_mmm_report) | **POST** /ad_accounts/{ad_account_id}/mmm_reports | Create a request for a Marketing Mix Modeling (MMM) report
*AdAccountsApi* | [**analytics_create_report**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#analytics_create_report) | **POST** /ad_accounts/{ad_account_id}/reports | Create async request for an account analytics report
*AdAccountsApi* | [**analytics_create_template_report**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#analytics_create_template_report) | **POST** /ad_accounts/{ad_account_id}/templates/{template_id}/reports | Create async request for an analytics report using a template
*AdAccountsApi* | [**analytics_get_mmm_report**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#analytics_get_mmm_report) | **GET** /ad_accounts/{ad_account_id}/mmm_reports | Get advertiser Marketing Mix Modeling (MMM) report.
*AdAccountsApi* | [**analytics_get_report**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#analytics_get_report) | **GET** /ad_accounts/{ad_account_id}/reports | Get the account analytics report created by the async call
*AdAccountsApi* | [**sandbox_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#sandbox_delete) | **DELETE** /ad_accounts/{ad_account_id}/sandbox | Delete ads data for ad account in API Sandbox
*AdAccountsApi* | [**templates_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsApi.md#templates_list) | **GET** /ad_accounts/{ad_account_id}/templates | List templates
*AdGroupsApi* | [**ad_groups_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_analytics) | **GET** /ad_accounts/{ad_account_id}/ad_groups/analytics | Get ad group analytics
*AdGroupsApi* | [**ad_groups_audience_sizing**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_audience_sizing) | **POST** /ad_accounts/{ad_account_id}/ad_groups/audience_sizing | Get audience sizing
*AdGroupsApi* | [**ad_groups_bid_floor_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_bid_floor_get) | **POST** /ad_accounts/{ad_account_id}/bid_floor | Get bid floors
*AdGroupsApi* | [**ad_groups_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_create) | **POST** /ad_accounts/{ad_account_id}/ad_groups | Create ad groups
*AdGroupsApi* | [**ad_groups_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_get) | **GET** /ad_accounts/{ad_account_id}/ad_groups/{ad_group_id} | Get ad group
*AdGroupsApi* | [**ad_groups_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_list) | **GET** /ad_accounts/{ad_account_id}/ad_groups | List ad groups
*AdGroupsApi* | [**ad_groups_targeting_analytics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_targeting_analytics_get) | **GET** /ad_accounts/{ad_account_id}/ad_groups/targeting_analytics | Get targeting analytics for ad groups
*AdGroupsApi* | [**ad_groups_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsApi.md#ad_groups_update) | **PATCH** /ad_accounts/{ad_account_id}/ad_groups | Update ad groups
*AdsApi* | [**ad_previews_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ad_previews_create) | **POST** /ad_accounts/{ad_account_id}/ad_previews | Create ad preview with pin or image
*AdsApi* | [**ad_targeting_analytics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ad_targeting_analytics_get) | **GET** /ad_accounts/{ad_account_id}/ads/targeting_analytics | Get targeting analytics for ads
*AdsApi* | [**ads_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ads_analytics) | **GET** /ad_accounts/{ad_account_id}/ads/analytics | Get ad analytics
*AdsApi* | [**ads_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ads_create) | **POST** /ad_accounts/{ad_account_id}/ads | Create ads
*AdsApi* | [**ads_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ads_get) | **GET** /ad_accounts/{ad_account_id}/ads/{ad_id} | Get ad
*AdsApi* | [**ads_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ads_list) | **GET** /ad_accounts/{ad_account_id}/ads | List ads
*AdsApi* | [**ads_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsApi.md#ads_update) | **PATCH** /ad_accounts/{ad_account_id}/ads | Update ads
*AdvancedAuctionApi* | [**advanced_auction_items_get_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionApi.md#advanced_auction_items_get_post) | **POST** /advanced_auction/items/get | Get item bid options (POST)
*AdvancedAuctionApi* | [**advanced_auction_items_submit_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionApi.md#advanced_auction_items_submit_post) | **POST** /advanced_auction/items/submit | Operate on item level bid options
*AudienceInsightsApi* | [**audience_insights_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightsApi.md#audience_insights_get) | **GET** /ad_accounts/{ad_account_id}/audience_insights | Get audience insights
*AudienceInsightsApi* | [**audience_insights_scope_and_type_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightsApi.md#audience_insights_scope_and_type_get) | **GET** /ad_accounts/{ad_account_id}/insights/audiences | Get audience insights scope and type
*AudienceSharingApi* | [**ad_accounts_audiences_shared_accounts_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#ad_accounts_audiences_shared_accounts_list) | **GET** /ad_accounts/{ad_account_id}/audiences/shared/accounts | List accounts with access to an audience owned by an ad account
*AudienceSharingApi* | [**business_account_audiences_shared_accounts_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#business_account_audiences_shared_accounts_list) | **GET** /businesses/{business_id}/audiences/shared/accounts | List accounts with access to an audience owned by a business
*AudienceSharingApi* | [**shared_audiences_for_business_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#shared_audiences_for_business_list) | **GET** /businesses/{business_id}/audiences | List received audiences for a business
*AudienceSharingApi* | [**update_ad_account_to_ad_account_shared_audience**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#update_ad_account_to_ad_account_shared_audience) | **PATCH** /ad_accounts/{ad_account_id}/audiences/ad_accounts/shared | Update audience sharing between ad accounts
*AudienceSharingApi* | [**update_ad_account_to_business_shared_audience**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#update_ad_account_to_business_shared_audience) | **PATCH** /ad_accounts/{ad_account_id}/audiences/businesses/shared | Update audience sharing from an ad account to businesses
*AudienceSharingApi* | [**update_business_to_ad_account_shared_audience**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#update_business_to_ad_account_shared_audience) | **PATCH** /businesses/{business_id}/audiences/ad_accounts/shared | Update audience sharing from a business to ad accounts
*AudienceSharingApi* | [**update_business_to_business_shared_audience**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingApi.md#update_business_to_business_shared_audience) | **PATCH** /businesses/{business_id}/audiences/businesses/shared | Update audience sharing between businesses
*AudiencesApi* | [**audiences_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudiencesApi.md#audiences_create) | **POST** /ad_accounts/{ad_account_id}/audiences | Create audience
*AudiencesApi* | [**audiences_create_custom**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudiencesApi.md#audiences_create_custom) | **POST** /ad_accounts/{ad_account_id}/audiences/custom | Create custom audience
*AudiencesApi* | [**audiences_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudiencesApi.md#audiences_get) | **GET** /ad_accounts/{ad_account_id}/audiences/{audience_id} | Get audience
*AudiencesApi* | [**audiences_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudiencesApi.md#audiences_list) | **GET** /ad_accounts/{ad_account_id}/audiences | List audiences
*AudiencesApi* | [**audiences_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudiencesApi.md#audiences_update) | **PATCH** /ad_accounts/{ad_account_id}/audiences/{audience_id} | Update audience
*BillingApi* | [**ads_credit_redeem**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ads_credit_redeem) | **POST** /ad_accounts/{ad_account_id}/ads_credit/redeem | Redeem ad credits
*BillingApi* | [**ads_credits_discounts_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ads_credits_discounts_get) | **GET** /ad_accounts/{ad_account_id}/ads_credit/discounts | Get ads credit discounts
*BillingApi* | [**billing_profiles_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#billing_profiles_get) | **GET** /ad_accounts/{ad_account_id}/billing_profiles | Get billing profiles
*BillingApi* | [**ssio_accounts_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_accounts_get) | **GET** /ad_accounts/{ad_account_id}/ssio/accounts | Get Salesforce account details including bill-to information.
*BillingApi* | [**ssio_insertion_order_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_insertion_order_create) | **POST** /ad_accounts/{ad_account_id}/ssio/insertion_orders | Create insertion order through SSIO.
*BillingApi* | [**ssio_insertion_order_edit**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_insertion_order_edit) | **PATCH** /ad_accounts/{ad_account_id}/ssio/insertion_orders | Edit insertion order through SSIO.
*BillingApi* | [**ssio_insertion_orders_status_get_by_ad_account**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_insertion_orders_status_get_by_ad_account) | **GET** /ad_accounts/{ad_account_id}/ssio/insertion_orders/status | Get insertion order status by ad account id.
*BillingApi* | [**ssio_insertion_orders_status_get_by_pin_order_id**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_insertion_orders_status_get_by_pin_order_id) | **GET** /ad_accounts/{ad_account_id}/ssio/insertion_orders/{pin_order_id}/status | Get insertion order status by pin order id.
*BillingApi* | [**ssio_order_lines_get_by_ad_account**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingApi.md#ssio_order_lines_get_by_ad_account) | **GET** /ad_accounts/{ad_account_id}/ssio/order_lines | Get Salesforce order lines by ad account id.
*BoardsApi* | [**board_sections_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#board_sections_create) | **POST** /boards/{board_id}/sections | Create board section
*BoardsApi* | [**board_sections_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#board_sections_delete) | **DELETE** /boards/{board_id}/sections/{section_id} | Delete board section
*BoardsApi* | [**board_sections_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#board_sections_list) | **GET** /boards/{board_id}/sections | List board sections
*BoardsApi* | [**board_sections_list_pins**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#board_sections_list_pins) | **GET** /boards/{board_id}/sections/{section_id}/pins | List Pins on board section
*BoardsApi* | [**board_sections_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#board_sections_update) | **PATCH** /boards/{board_id}/sections/{section_id} | Update board section
*BoardsApi* | [**boards_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_create) | **POST** /boards | Create board
*BoardsApi* | [**boards_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_delete) | **DELETE** /boards/{board_id} | Delete board
*BoardsApi* | [**boards_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_get) | **GET** /boards/{board_id} | Get board
*BoardsApi* | [**boards_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_list) | **GET** /boards | List boards
*BoardsApi* | [**boards_list_pins**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_list_pins) | **GET** /boards/{board_id}/pins | List Pins on board
*BoardsApi* | [**boards_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardsApi.md#boards_update) | **PATCH** /boards/{board_id} | Update board
*BulkApi* | [**bulk_download_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkApi.md#bulk_download_create) | **POST** /ad_accounts/{ad_account_id}/bulk/download | Get advertiser entities in bulk
*BulkApi* | [**bulk_request_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkApi.md#bulk_request_get) | **GET** /ad_accounts/{ad_account_id}/bulk/{bulk_request_id} | Download advertiser entities in bulk
*BulkApi* | [**bulk_upsert_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkApi.md#bulk_upsert_create) | **POST** /ad_accounts/{ad_account_id}/bulk/upsert | Create/update ad entities in bulk
*BusinessAccessAssetsApi* | [**asset_group_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#asset_group_create) | **POST** /businesses/{business_id}/asset_groups | Create a new asset group.
*BusinessAccessAssetsApi* | [**asset_group_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#asset_group_delete) | **DELETE** /businesses/{business_id}/asset_groups | Delete asset groups.
*BusinessAccessAssetsApi* | [**asset_group_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#asset_group_update) | **PATCH** /businesses/{business_id}/asset_groups | Update asset groups.
*BusinessAccessAssetsApi* | [**business_asset_members_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_asset_members_get) | **GET** /businesses/{business_id}/assets/{asset_id}/members | Get members with access to asset
*BusinessAccessAssetsApi* | [**business_asset_partners_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_asset_partners_get) | **GET** /businesses/{business_id}/assets/{asset_id}/partners | Get partners with access to asset
*BusinessAccessAssetsApi* | [**business_assets_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_assets_get) | **GET** /businesses/{business_id}/assets | List business assets
*BusinessAccessAssetsApi* | [**business_member_assets_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_member_assets_get) | **GET** /businesses/{business_id}/members/{member_id}/assets | Get assets assigned to a member
*BusinessAccessAssetsApi* | [**business_members_asset_access_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_members_asset_access_delete) | **DELETE** /businesses/{business_id}/members/assets/access | Delete member access to asset
*BusinessAccessAssetsApi* | [**business_members_asset_access_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_members_asset_access_update) | **PATCH** /businesses/{business_id}/members/assets/access | Assign/Update member asset permissions
*BusinessAccessAssetsApi* | [**business_partner_asset_access_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#business_partner_asset_access_get) | **GET** /businesses/{business_id}/partners/{partner_id}/assets | Get assets assigned to a partner or assets assigned by a partner
*BusinessAccessAssetsApi* | [**delete_partner_asset_access_handler_impl**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#delete_partner_asset_access_handler_impl) | **DELETE** /businesses/{business_id}/partners/assets | Delete partner access to asset
*BusinessAccessAssetsApi* | [**update_partner_asset_access_handler_impl**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessAssetsApi.md#update_partner_asset_access_handler_impl) | **PATCH** /businesses/{business_id}/partners/assets | Assign/Update partner asset permissions
*BusinessAccessInviteApi* | [**asset_access_requests_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#asset_access_requests_create) | **POST** /businesses/{business_id}/requests/assets/access | Create a request to access an existing partner&#39;s assets.
*BusinessAccessInviteApi* | [**cancel_invites_or_requests**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#cancel_invites_or_requests) | **DELETE** /businesses/{business_id}/invites | Cancel invites/requests
*BusinessAccessInviteApi* | [**create_asset_invites**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#create_asset_invites) | **POST** /businesses/{business_id}/invites/assets/access | Update invite/request with an asset permission
*BusinessAccessInviteApi* | [**create_membership_or_partnership_invites**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#create_membership_or_partnership_invites) | **POST** /businesses/{business_id}/invites | Create invites or requests
*BusinessAccessInviteApi* | [**get_invites**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#get_invites) | **GET** /businesses/{business_id}/invites | Get invites/requests
*BusinessAccessInviteApi* | [**respond_business_access_invites**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessInviteApi.md#respond_business_access_invites) | **PATCH** /businesses/invites | Accept or decline an invite/request
*BusinessAccessRelationshipsApi* | [**delete_business_membership**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#delete_business_membership) | **DELETE** /businesses/{business_id}/members | Terminate business memberships
*BusinessAccessRelationshipsApi* | [**delete_business_partners**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#delete_business_partners) | **DELETE** /businesses/{business_id}/partners | Terminate business partnerships
*BusinessAccessRelationshipsApi* | [**get_business_employers**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#get_business_employers) | **GET** /businesses/employers | List business employers for user
*BusinessAccessRelationshipsApi* | [**get_business_members**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#get_business_members) | **GET** /businesses/{business_id}/members | Get business members
*BusinessAccessRelationshipsApi* | [**get_business_partners**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#get_business_partners) | **GET** /businesses/{business_id}/partners | Get business partners
*BusinessAccessRelationshipsApi* | [**update_business_memberships**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRelationshipsApi.md#update_business_memberships) | **PATCH** /businesses/{business_id}/members | Update member&#39;s business role
*CampaignsApi* | [**campaign_targeting_analytics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaign_targeting_analytics_get) | **GET** /ad_accounts/{ad_account_id}/campaigns/targeting_analytics | Get targeting analytics for campaigns
*CampaignsApi* | [**campaigns_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaigns_analytics) | **GET** /ad_accounts/{ad_account_id}/campaigns/analytics | Get campaign analytics
*CampaignsApi* | [**campaigns_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaigns_create) | **POST** /ad_accounts/{ad_account_id}/campaigns | Create campaigns
*CampaignsApi* | [**campaigns_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaigns_get) | **GET** /ad_accounts/{ad_account_id}/campaigns/{campaign_id} | Get campaign
*CampaignsApi* | [**campaigns_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaigns_list) | **GET** /ad_accounts/{ad_account_id}/campaigns | List campaigns
*CampaignsApi* | [**campaigns_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsApi.md#campaigns_update) | **PATCH** /ad_accounts/{ad_account_id}/campaigns | Update campaigns
*CatalogsApi* | [**catalogs_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_create) | **POST** /catalogs | Create catalog
*CatalogsApi* | [**catalogs_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_list) | **GET** /catalogs | List catalogs
*CatalogsApi* | [**catalogs_product_group_pins_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_group_pins_list) | **GET** /catalogs/product_groups/{product_group_id}/products | List products by product group
*CatalogsApi* | [**catalogs_product_groups_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_create) | **POST** /catalogs/product_groups | Create product group
*CatalogsApi* | [**catalogs_product_groups_create_many**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_create_many) | **POST** /catalogs/product_groups/multiple | Create product groups
*CatalogsApi* | [**catalogs_product_groups_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_delete) | **DELETE** /catalogs/product_groups/{product_group_id} | Delete product group
*CatalogsApi* | [**catalogs_product_groups_delete_many**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_delete_many) | **DELETE** /catalogs/product_groups/multiple | Delete product groups
*CatalogsApi* | [**catalogs_product_groups_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_get) | **GET** /catalogs/product_groups/{product_group_id} | Get product group
*CatalogsApi* | [**catalogs_product_groups_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_list) | **GET** /catalogs/product_groups | List product groups
*CatalogsApi* | [**catalogs_product_groups_product_counts_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_product_counts_get) | **GET** /catalogs/product_groups/{product_group_id}/product_counts | Get product counts
*CatalogsApi* | [**catalogs_product_groups_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#catalogs_product_groups_update) | **PATCH** /catalogs/product_groups/{product_group_id} | Update single product group
*CatalogsApi* | [**feed_processing_results_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feed_processing_results_list) | **GET** /catalogs/feeds/{feed_id}/processing_results | List feed processing results
*CatalogsApi* | [**feeds_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_create) | **POST** /catalogs/feeds | Create feed
*CatalogsApi* | [**feeds_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_delete) | **DELETE** /catalogs/feeds/{feed_id} | Delete feed
*CatalogsApi* | [**feeds_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_get) | **GET** /catalogs/feeds/{feed_id} | Get feed
*CatalogsApi* | [**feeds_ingest**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_ingest) | **POST** /catalogs/feeds/{feed_id}/ingest | Ingest feed items
*CatalogsApi* | [**feeds_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_list) | **GET** /catalogs/feeds | List feeds
*CatalogsApi* | [**feeds_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#feeds_update) | **PATCH** /catalogs/feeds/{feed_id} | Update feed
*CatalogsApi* | [**items_batch_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#items_batch_get) | **GET** /catalogs/items/batch/{batch_id} | Get item batch status
*CatalogsApi* | [**items_batch_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#items_batch_post) | **POST** /catalogs/items/batch | Operate on item batch
*CatalogsApi* | [**items_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#items_get) | **GET** /catalogs/items | Get catalogs items
*CatalogsApi* | [**items_issues_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#items_issues_list) | **GET** /catalogs/processing_results/{processing_result_id}/item_issues | List item issues
*CatalogsApi* | [**items_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#items_post) | **POST** /catalogs/items | Get catalogs items (POST)
*CatalogsApi* | [**products_by_product_group_filter_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#products_by_product_group_filter_list) | **POST** /catalogs/products/get_by_product_group_filters | List products by filter
*CatalogsApi* | [**reports_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#reports_create) | **POST** /catalogs/reports | Build catalogs report
*CatalogsApi* | [**reports_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#reports_get) | **GET** /catalogs/reports | Get catalogs report
*CatalogsApi* | [**reports_stats**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsApi.md#reports_stats) | **GET** /catalogs/reports/stats | List report stats
*ConversionEventsApi* | [**events_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsApi.md#events_create) | **POST** /ad_accounts/{ad_account_id}/events | Send conversions
*ConversionTagsApi* | [**conversion_tags_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsApi.md#conversion_tags_create) | **POST** /ad_accounts/{ad_account_id}/conversion_tags | Create conversion tag
*ConversionTagsApi* | [**conversion_tags_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsApi.md#conversion_tags_get) | **GET** /ad_accounts/{ad_account_id}/conversion_tags/{conversion_tag_id} | Get conversion tag
*ConversionTagsApi* | [**conversion_tags_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsApi.md#conversion_tags_list) | **GET** /ad_accounts/{ad_account_id}/conversion_tags | Get conversion tags
*ConversionTagsApi* | [**ocpm_eligible_conversion_tags_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsApi.md#ocpm_eligible_conversion_tags_get) | **GET** /ad_accounts/{ad_account_id}/conversion_tags/ocpm_eligible | Get Ocpm eligible conversion tags
*ConversionTagsApi* | [**page_visit_conversion_tags_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsApi.md#page_visit_conversion_tags_get) | **GET** /ad_accounts/{ad_account_id}/conversion_tags/page_visit | Get page visit conversion tags
*CustomerListsApi* | [**customer_lists_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListsApi.md#customer_lists_create) | **POST** /ad_accounts/{ad_account_id}/customer_lists | Create customer lists
*CustomerListsApi* | [**customer_lists_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListsApi.md#customer_lists_get) | **GET** /ad_accounts/{ad_account_id}/customer_lists/{customer_list_id} | Get customer list
*CustomerListsApi* | [**customer_lists_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListsApi.md#customer_lists_list) | **GET** /ad_accounts/{ad_account_id}/customer_lists | Get customer lists
*CustomerListsApi* | [**customer_lists_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListsApi.md#customer_lists_update) | **PATCH** /ad_accounts/{ad_account_id}/customer_lists/{customer_list_id} | Update customer list
*IntegrationsApi* | [**integrations_commerce_del**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_commerce_del) | **DELETE** /integrations/commerce/{external_business_id} | Delete commerce integration
*IntegrationsApi* | [**integrations_commerce_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_commerce_get) | **GET** /integrations/commerce/{external_business_id} | Get commerce integration
*IntegrationsApi* | [**integrations_commerce_patch**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_commerce_patch) | **PATCH** /integrations/commerce/{external_business_id} | Update commerce integration
*IntegrationsApi* | [**integrations_commerce_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_commerce_post) | **POST** /integrations/commerce | Create commerce integration
*IntegrationsApi* | [**integrations_get_by_id**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_get_by_id) | **GET** /integrations/{id} | Get integration metadata
*IntegrationsApi* | [**integrations_get_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_get_list) | **GET** /integrations | Get integration metadata list
*IntegrationsApi* | [**integrations_logs_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationsApi.md#integrations_logs_post) | **POST** /integrations/logs | Receives batched logs from integration applications.
*KeywordsApi* | [**country_keywords_metrics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsApi.md#country_keywords_metrics_get) | **GET** /ad_accounts/{ad_account_id}/keywords/metrics | Get country&#39;s keyword metrics
*KeywordsApi* | [**keywords_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsApi.md#keywords_create) | **POST** /ad_accounts/{ad_account_id}/keywords | Create keywords
*KeywordsApi* | [**keywords_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsApi.md#keywords_get) | **GET** /ad_accounts/{ad_account_id}/keywords | Get keywords
*KeywordsApi* | [**keywords_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsApi.md#keywords_update) | **PATCH** /ad_accounts/{ad_account_id}/keywords | Update keywords
*KeywordsApi* | [**trending_keywords_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsApi.md#trending_keywords_list) | **GET** /trends/keywords/{region}/top/{trend_type} | List trending keywords
*LeadAdsApi* | [**ad_accounts_subscriptions_del_by_id**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadAdsApi.md#ad_accounts_subscriptions_del_by_id) | **DELETE** /ad_accounts/{ad_account_id}/leads/subscriptions/{subscription_id} | Delete lead ads subscription
*LeadAdsApi* | [**ad_accounts_subscriptions_get_by_id**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadAdsApi.md#ad_accounts_subscriptions_get_by_id) | **GET** /ad_accounts/{ad_account_id}/leads/subscriptions/{subscription_id} | Get lead ads subscription
*LeadAdsApi* | [**ad_accounts_subscriptions_get_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadAdsApi.md#ad_accounts_subscriptions_get_list) | **GET** /ad_accounts/{ad_account_id}/leads/subscriptions | Get lead ads subscriptions
*LeadAdsApi* | [**ad_accounts_subscriptions_post**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadAdsApi.md#ad_accounts_subscriptions_post) | **POST** /ad_accounts/{ad_account_id}/leads/subscriptions | Create lead ads subscription
*LeadFormsApi* | [**lead_form_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormsApi.md#lead_form_get) | **GET** /ad_accounts/{ad_account_id}/lead_forms/{lead_form_id} | Get lead form by id
*LeadFormsApi* | [**lead_form_test_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormsApi.md#lead_form_test_create) | **POST** /ad_accounts/{ad_account_id}/lead_forms/{lead_form_id}/test | Create lead form test data
*LeadFormsApi* | [**lead_forms_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormsApi.md#lead_forms_create) | **POST** /ad_accounts/{ad_account_id}/lead_forms | Create lead forms
*LeadFormsApi* | [**lead_forms_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormsApi.md#lead_forms_list) | **GET** /ad_accounts/{ad_account_id}/lead_forms | List lead forms
*LeadFormsApi* | [**lead_forms_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormsApi.md#lead_forms_update) | **PATCH** /ad_accounts/{ad_account_id}/lead_forms | Update lead forms
*LeadsExportApi* | [**leads_export_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportApi.md#leads_export_create) | **POST** /ad_accounts/{ad_account_id}/leads_export | Create a request to export leads collected from a lead ad
*LeadsExportApi* | [**leads_export_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportApi.md#leads_export_get) | **GET** /ad_accounts/{ad_account_id}/leads_export/{leads_export_id} | Get the lead export from the lead export create call
*MediaApi* | [**media_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaApi.md#media_create) | **POST** /media | Register media upload
*MediaApi* | [**media_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaApi.md#media_get) | **GET** /media/{media_id} | Get media upload details
*MediaApi* | [**media_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaApi.md#media_list) | **GET** /media | List media uploads
*OauthApi* | [**oauth_token**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthApi.md#oauth_token) | **POST** /oauth/token | Generate OAuth access token
*OrderLinesApi* | [**order_lines_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLinesApi.md#order_lines_get) | **GET** /ad_accounts/{ad_account_id}/order_lines/{order_line_id} | Get order line
*OrderLinesApi* | [**order_lines_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLinesApi.md#order_lines_list) | **GET** /ad_accounts/{ad_account_id}/order_lines | Get order lines
*PinsApi* | [**multi_pins_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#multi_pins_analytics) | **GET** /pins/analytics | Get multiple Pin analytics
*PinsApi* | [**pins_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_analytics) | **GET** /pins/{pin_id}/analytics | Get Pin analytics
*PinsApi* | [**pins_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_create) | **POST** /pins | Create Pin
*PinsApi* | [**pins_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_delete) | **DELETE** /pins/{pin_id} | Delete Pin
*PinsApi* | [**pins_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_get) | **GET** /pins/{pin_id} | Get Pin
*PinsApi* | [**pins_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_list) | **GET** /pins | List Pins
*PinsApi* | [**pins_save**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_save) | **POST** /pins/{pin_id}/save | Save Pin
*PinsApi* | [**pins_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinsApi.md#pins_update) | **PATCH** /pins/{pin_id} | Update Pin
*ProductGroupPromotionsApi* | [**product_group_promotions_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionsApi.md#product_group_promotions_create) | **POST** /ad_accounts/{ad_account_id}/product_group_promotions | Create product group promotions
*ProductGroupPromotionsApi* | [**product_group_promotions_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionsApi.md#product_group_promotions_get) | **GET** /ad_accounts/{ad_account_id}/product_group_promotions/{product_group_promotion_id} | Get a product group promotion by id
*ProductGroupPromotionsApi* | [**product_group_promotions_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionsApi.md#product_group_promotions_list) | **GET** /ad_accounts/{ad_account_id}/product_group_promotions | Get product group promotions
*ProductGroupPromotionsApi* | [**product_group_promotions_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionsApi.md#product_group_promotions_update) | **PATCH** /ad_accounts/{ad_account_id}/product_group_promotions | Update product group promotions
*ProductGroupPromotionsApi* | [**product_groups_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionsApi.md#product_groups_analytics) | **GET** /ad_accounts/{ad_account_id}/product_groups/analytics | Get product group analytics
*ResourcesApi* | [**ad_account_countries_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#ad_account_countries_get) | **GET** /resources/ad_account_countries | Get ad accounts countries
*ResourcesApi* | [**delivery_metrics_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#delivery_metrics_get) | **GET** /resources/delivery_metrics | Get available metrics&#39; definitions
*ResourcesApi* | [**interest_targeting_options_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#interest_targeting_options_get) | **GET** /resources/targeting/interests/{interest_id} | Get interest details
*ResourcesApi* | [**lead_form_questions_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#lead_form_questions_get) | **GET** /resources/lead_form_questions | Get lead form questions
*ResourcesApi* | [**metrics_ready_state_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#metrics_ready_state_get) | **GET** /resources/metrics_ready_state | Get metrics ready state
*ResourcesApi* | [**targeting_options_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ResourcesApi.md#targeting_options_get) | **GET** /resources/targeting/{targeting_type} | Get targeting options
*SearchApi* | [**search_partner_pins**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SearchApi.md#search_partner_pins) | **GET** /search/partner/pins | Search pins by a given search term
*SearchApi* | [**search_user_boards_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SearchApi.md#search_user_boards_get) | **GET** /search/boards | Search user&#39;s boards
*SearchApi* | [**search_user_pins_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SearchApi.md#search_user_pins_list) | **GET** /search/pins | Search user&#39;s Pins
*TargetingTemplateApi* | [**targeting_template_create**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateApi.md#targeting_template_create) | **POST** /ad_accounts/{ad_account_id}/targeting_templates | Create targeting templates
*TargetingTemplateApi* | [**targeting_template_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateApi.md#targeting_template_list) | **GET** /ad_accounts/{ad_account_id}/targeting_templates | List targeting templates
*TargetingTemplateApi* | [**targeting_template_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateApi.md#targeting_template_update) | **PATCH** /ad_accounts/{ad_account_id}/targeting_templates | Update targeting templates
*TermsApi* | [**terms_related_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TermsApi.md#terms_related_list) | **GET** /terms/related | List related terms
*TermsApi* | [**terms_suggested_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TermsApi.md#terms_suggested_list) | **GET** /terms/suggested | List suggested terms
*TermsOfServiceApi* | [**terms_of_service_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TermsOfServiceApi.md#terms_of_service_get) | **GET** /ad_accounts/{ad_account_id}/terms_of_service | Get terms of service
*UserAccountApi* | [**boards_user_follows_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#boards_user_follows_list) | **GET** /user_account/following/boards | List following boards
*UserAccountApi* | [**follow_user_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#follow_user_update) | **POST** /user_account/following/{username} | Follow user
*UserAccountApi* | [**followers_list**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#followers_list) | **GET** /user_account/followers | List followers
*UserAccountApi* | [**linked_business_accounts_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#linked_business_accounts_get) | **GET** /user_account/businesses | List linked businesses
*UserAccountApi* | [**unverify_website_delete**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#unverify_website_delete) | **DELETE** /user_account/websites | Unverify website
*UserAccountApi* | [**user_account_analytics**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_account_analytics) | **GET** /user_account/analytics | Get user account analytics
*UserAccountApi* | [**user_account_analytics_top_pins**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_account_analytics_top_pins) | **GET** /user_account/analytics/top_pins | Get user account top pins analytics
*UserAccountApi* | [**user_account_analytics_top_video_pins**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_account_analytics_top_video_pins) | **GET** /user_account/analytics/top_video_pins | Get user account top video pins analytics
*UserAccountApi* | [**user_account_followed_interests**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_account_followed_interests) | **GET** /users/{username}/interests/follow | List following interests
*UserAccountApi* | [**user_account_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_account_get) | **GET** /user_account | Get user account
*UserAccountApi* | [**user_following_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_following_get) | **GET** /user_account/following | List following
*UserAccountApi* | [**user_websites_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#user_websites_get) | **GET** /user_account/websites | Get user websites
*UserAccountApi* | [**verify_website_update**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#verify_website_update) | **POST** /user_account/websites | Verify website
*UserAccountApi* | [**website_verification_get**](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserAccountApi.md#website_verification_get) | **GET** /user_account/websites/verification | Get user verification code for website claiming


## Documentation For Models

 - [Account](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Account.md)
 - [ActionType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ActionType.md)
 - [AdAccount](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccount.md)
 - [AdAccountAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountAnalyticsResponse.md)
 - [AdAccountCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountCreateRequest.md)
 - [AdAccountCreateSubscriptionRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountCreateSubscriptionRequest.md)
 - [AdAccountCreateSubscriptionRequestPartnerMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountCreateSubscriptionRequestPartnerMetadata.md)
 - [AdAccountCreateSubscriptionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountCreateSubscriptionResponse.md)
 - [AdAccountGetSubscriptionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountGetSubscriptionResponse.md)
 - [AdAccountGetSubscriptionResponseAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountGetSubscriptionResponseAllOf.md)
 - [AdAccountGetSubscriptionResponseAllOf1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountGetSubscriptionResponseAllOf1.md)
 - [AdAccountOwner](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountOwner.md)
 - [AdAccountsCountryResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsCountryResponse.md)
 - [AdAccountsCountryResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdAccountsCountryResponseData.md)
 - [AdArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdArrayResponse.md)
 - [AdArrayResponseElement](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdArrayResponseElement.md)
 - [AdCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdCommon.md)
 - [AdCountry](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdCountry.md)
 - [AdCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdCreateRequest.md)
 - [AdGroupArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupArrayResponse.md)
 - [AdGroupArrayResponseElement](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupArrayResponseElement.md)
 - [AdGroupAudienceSizingRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupAudienceSizingRequest.md)
 - [AdGroupAudienceSizingRequestKeywords](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupAudienceSizingRequestKeywords.md)
 - [AdGroupAudienceSizingResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupAudienceSizingResponse.md)
 - [AdGroupCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupCommon.md)
 - [AdGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupCreateRequest.md)
 - [AdGroupCreateRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupCreateRequestAllOf.md)
 - [AdGroupResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupResponse.md)
 - [AdGroupResponseAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupResponseAllOf.md)
 - [AdGroupSummaryStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupSummaryStatus.md)
 - [AdGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupUpdateRequest.md)
 - [AdGroupUpdateRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupUpdateRequestAllOf.md)
 - [AdGroupsAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdGroupsAnalyticsResponse.md)
 - [AdPinId](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdPinId.md)
 - [AdPreviewCreateFromImage](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdPreviewCreateFromImage.md)
 - [AdPreviewCreateFromPin](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdPreviewCreateFromPin.md)
 - [AdPreviewRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdPreviewRequest.md)
 - [AdPreviewURLResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdPreviewURLResponse.md)
 - [AdResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdResponse.md)
 - [AdResponseAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdResponseAllOf.md)
 - [AdUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdUpdateRequest.md)
 - [AdUpdateRequest1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdUpdateRequest1.md)
 - [AdsAnalyticsAdTargetingType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsAdTargetingType.md)
 - [AdsAnalyticsCampaignTargetingType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsCampaignTargetingType.md)
 - [AdsAnalyticsCreateAsyncRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsCreateAsyncRequest.md)
 - [AdsAnalyticsCreateAsyncRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsCreateAsyncRequestAllOf.md)
 - [AdsAnalyticsCreateAsyncRequestAllOf1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsCreateAsyncRequestAllOf1.md)
 - [AdsAnalyticsCreateAsyncResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsCreateAsyncResponse.md)
 - [AdsAnalyticsFilterColumn](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsFilterColumn.md)
 - [AdsAnalyticsFilterOperator](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsFilterOperator.md)
 - [AdsAnalyticsGetAsyncResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsGetAsyncResponse.md)
 - [AdsAnalyticsMetricsFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsMetricsFilter.md)
 - [AdsAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsResponse.md)
 - [AdsAnalyticsTargetingType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsAnalyticsTargetingType.md)
 - [AdsCreditDiscountsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsCreditDiscountsResponse.md)
 - [AdsCreditRedeemRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsCreditRedeemRequest.md)
 - [AdsCreditRedeemResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdsCreditRedeemResponse.md)
 - [AdvancedAuctionBidOptions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionBidOptions.md)
 - [AdvancedAuctionItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItem.md)
 - [AdvancedAuctionItemAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemAllOf.md)
 - [AdvancedAuctionItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItems.md)
 - [AdvancedAuctionItemsGetRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsGetRecord.md)
 - [AdvancedAuctionItemsGetRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsGetRequest.md)
 - [AdvancedAuctionItemsSubmitDeleteRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsSubmitDeleteRecord.md)
 - [AdvancedAuctionItemsSubmitRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsSubmitRecord.md)
 - [AdvancedAuctionItemsSubmitRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsSubmitRequest.md)
 - [AdvancedAuctionItemsSubmitUpsertRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsSubmitUpsertRecord.md)
 - [AdvancedAuctionItemsSubmitUpsertRecordAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionItemsSubmitUpsertRecordAllOf.md)
 - [AdvancedAuctionKey](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionKey.md)
 - [AdvancedAuctionOperation](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionOperation.md)
 - [AdvancedAuctionOperationError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionOperationError.md)
 - [AdvancedAuctionProcessedItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionProcessedItem.md)
 - [AdvancedAuctionProcessedItemAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionProcessedItemAllOf.md)
 - [AdvancedAuctionProcessedItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AdvancedAuctionProcessedItems.md)
 - [AgeBucketList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AgeBucketList.md)
 - [AnalyticsDailyMetrics](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AnalyticsDailyMetrics.md)
 - [AnalyticsMetricsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AnalyticsMetricsResponse.md)
 - [AnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AnalyticsResponse.md)
 - [AppTypeMultipliers](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AppTypeMultipliers.md)
 - [AssetGroupBinding](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AssetGroupBinding.md)
 - [AssetGroupType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AssetGroupType.md)
 - [AssetGroupTypes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AssetGroupTypes.md)
 - [AssetIdPermissions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AssetIdPermissions.md)
 - [AssetIdToPermissions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AssetIdToPermissions.md)
 - [Audience](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Audience.md)
 - [AudienceAccountType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceAccountType.md)
 - [AudienceCategory](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCategory.md)
 - [AudienceCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCommon.md)
 - [AudienceCreateCustomRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCreateCustomRequest.md)
 - [AudienceCreateCustomRequest1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCreateCustomRequest1.md)
 - [AudienceCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCreateRequest.md)
 - [AudienceCreateRequest1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceCreateRequest1.md)
 - [AudienceDataParty](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceDataParty.md)
 - [AudienceDefinition](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceDefinition.md)
 - [AudienceDefinitionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceDefinitionResponse.md)
 - [AudienceDemographicValue](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceDemographicValue.md)
 - [AudienceDemographics](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceDemographics.md)
 - [AudienceInsightCategoryArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightCategoryArrayResponse.md)
 - [AudienceInsightCategoryCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightCategoryCommon.md)
 - [AudienceInsightType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightType.md)
 - [AudienceInsightsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceInsightsResponse.md)
 - [AudienceRule](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceRule.md)
 - [AudienceShareType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceShareType.md)
 - [AudienceSharingType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSharingType.md)
 - [AudienceSubcategory](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceSubcategory.md)
 - [AudienceType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceType.md)
 - [AudienceUpdateOperationType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceUpdateOperationType.md)
 - [AudienceUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceUpdateRequest.md)
 - [AudienceUpdateRequest1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AudienceUpdateRequest1.md)
 - [AuthRespondInvitesBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AuthRespondInvitesBody.md)
 - [AuthRespondInvitesBodyAction](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AuthRespondInvitesBodyAction.md)
 - [AuthRespondInvitesBodyInvites](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AuthRespondInvitesBodyInvites.md)
 - [AvailabilityFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/AvailabilityFilter.md)
 - [BaseInviteDataResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BaseInviteDataResponse.md)
 - [BaseInviteDataResponseInviteData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BaseInviteDataResponseInviteData.md)
 - [BatchOperation](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BatchOperation.md)
 - [BatchOperationStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BatchOperationStatus.md)
 - [BidFloor](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BidFloor.md)
 - [BidFloorRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BidFloorRequest.md)
 - [BidFloorSpec](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BidFloorSpec.md)
 - [BillingProfilesResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BillingProfilesResponse.md)
 - [Board](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Board.md)
 - [BoardMedia](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardMedia.md)
 - [BoardOwner](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardOwner.md)
 - [BoardSection](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardSection.md)
 - [BoardUpdate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BoardUpdate.md)
 - [BookClosedResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BookClosedResponse.md)
 - [BrandFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BrandFilter.md)
 - [BudgetType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BudgetType.md)
 - [BulkDownloadRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkDownloadRequest.md)
 - [BulkDownloadRequestCampaignFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkDownloadRequestCampaignFilter.md)
 - [BulkDownloadResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkDownloadResponse.md)
 - [BulkEntityType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkEntityType.md)
 - [BulkOutputFormat](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkOutputFormat.md)
 - [BulkPinAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkPinAnalyticsResponse.md)
 - [BulkReportingJobStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkReportingJobStatus.md)
 - [BulkUpsertRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertRequest.md)
 - [BulkUpsertRequestCreate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertRequestCreate.md)
 - [BulkUpsertRequestUpdate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertRequestUpdate.md)
 - [BulkUpsertResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertResponse.md)
 - [BulkUpsertStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertStatus.md)
 - [BulkUpsertStatusResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BulkUpsertStatusResponse.md)
 - [BusinessAccessError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessError.md)
 - [BusinessAccessRole](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessRole.md)
 - [BusinessAccessUserSummary](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessAccessUserSummary.md)
 - [BusinessMemberAssetsSummary](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessMemberAssetsSummary.md)
 - [BusinessMemberAssetsSummaryAdAccounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessMemberAssetsSummaryAdAccounts.md)
 - [BusinessMemberAssetsSummaryProfiles](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessMemberAssetsSummaryProfiles.md)
 - [BusinessRole](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessRole.md)
 - [BusinessRoleCheckMode](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessRoleCheckMode.md)
 - [BusinessRoleForMembers](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessRoleForMembers.md)
 - [BusinessSharedAudience](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessSharedAudience.md)
 - [BusinessSharedAudience1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessSharedAudience1.md)
 - [BusinessSharedAudienceResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessSharedAudienceResponse.md)
 - [BusinessSharedAudienceResponse1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessSharedAudienceResponse1.md)
 - [BusinessesBusinessIdMembersAssetsAccessAccesses](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/BusinessesBusinessIdMembersAssetsAccessAccesses.md)
 - [CampaignCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCommon.md)
 - [CampaignCreateCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateCommon.md)
 - [CampaignCreateCommonAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateCommonAllOf.md)
 - [CampaignCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateRequest.md)
 - [CampaignCreateRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateRequestAllOf.md)
 - [CampaignCreateResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateResponse.md)
 - [CampaignCreateResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateResponseData.md)
 - [CampaignCreateResponseDataAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateResponseDataAllOf.md)
 - [CampaignCreateResponseItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignCreateResponseItem.md)
 - [CampaignId](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignId.md)
 - [CampaignResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignResponse.md)
 - [CampaignResponseAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignResponseAllOf.md)
 - [CampaignSummaryStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignSummaryStatus.md)
 - [CampaignUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignUpdateRequest.md)
 - [CampaignUpdateRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignUpdateRequestAllOf.md)
 - [CampaignUpdateResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignUpdateResponse.md)
 - [CampaignsAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CampaignsAnalyticsResponse.md)
 - [CancelInvitesBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CancelInvitesBody.md)
 - [Catalog](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Catalog.md)
 - [CatalogAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogAllOf.md)
 - [CatalogsCreateCreativeAssetsItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreateCreativeAssetsItem.md)
 - [CatalogsCreateHotelItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreateHotelItem.md)
 - [CatalogsCreateReportResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreateReportResponse.md)
 - [CatalogsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreateRequest.md)
 - [CatalogsCreateRetailItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreateRetailItem.md)
 - [CatalogsCreativeAssetsAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsAttributes.md)
 - [CatalogsCreativeAssetsAttributesAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsAttributesAllOf.md)
 - [CatalogsCreativeAssetsBatchItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsBatchItem.md)
 - [CatalogsCreativeAssetsBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsBatchRequest.md)
 - [CatalogsCreativeAssetsFeed](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsFeed.md)
 - [CatalogsCreativeAssetsFeedsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsFeedsCreateRequest.md)
 - [CatalogsCreativeAssetsFeedsUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsFeedsUpdateRequest.md)
 - [CatalogsCreativeAssetsItemErrorResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsItemErrorResponse.md)
 - [CatalogsCreativeAssetsItemResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsItemResponse.md)
 - [CatalogsCreativeAssetsItemsBatch](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsItemsBatch.md)
 - [CatalogsCreativeAssetsItemsFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsItemsFilter.md)
 - [CatalogsCreativeAssetsItemsPostFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsItemsPostFilter.md)
 - [CatalogsCreativeAssetsListProductsByCatalogBasedFilterRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsListProductsByCatalogBasedFilterRequest.md)
 - [CatalogsCreativeAssetsProduct](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProduct.md)
 - [CatalogsCreativeAssetsProductGroup](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroup.md)
 - [CatalogsCreativeAssetsProductGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupCreateRequest.md)
 - [CatalogsCreativeAssetsProductGroupFilterKeys](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupFilterKeys.md)
 - [CatalogsCreativeAssetsProductGroupFilters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupFilters.md)
 - [CatalogsCreativeAssetsProductGroupFiltersAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupFiltersAllOf.md)
 - [CatalogsCreativeAssetsProductGroupFiltersAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupFiltersAnyOf.md)
 - [CatalogsCreativeAssetsProductGroupProductCounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupProductCounts.md)
 - [CatalogsCreativeAssetsProductGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductGroupUpdateRequest.md)
 - [CatalogsCreativeAssetsProductMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsCreativeAssetsProductMetadata.md)
 - [CatalogsDbItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsDbItem.md)
 - [CatalogsDeleteCreativeAssetsItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsDeleteCreativeAssetsItem.md)
 - [CatalogsDeleteHotelItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsDeleteHotelItem.md)
 - [CatalogsDeleteRetailItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsDeleteRetailItem.md)
 - [CatalogsFeed](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeed.md)
 - [CatalogsFeedCredentials](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedCredentials.md)
 - [CatalogsFeedIngestion](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedIngestion.md)
 - [CatalogsFeedIngestionDetails](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedIngestionDetails.md)
 - [CatalogsFeedIngestionErrors](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedIngestionErrors.md)
 - [CatalogsFeedIngestionInfo](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedIngestionInfo.md)
 - [CatalogsFeedIngestionWarnings](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedIngestionWarnings.md)
 - [CatalogsFeedProcessingResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedProcessingResult.md)
 - [CatalogsFeedProcessingResultFields](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedProcessingResultFields.md)
 - [CatalogsFeedProcessingSchedule](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedProcessingSchedule.md)
 - [CatalogsFeedProcessingStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedProcessingStatus.md)
 - [CatalogsFeedProductCounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedProductCounts.md)
 - [CatalogsFeedValidationDetails](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedValidationDetails.md)
 - [CatalogsFeedValidationErrors](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedValidationErrors.md)
 - [CatalogsFeedValidationWarnings](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedValidationWarnings.md)
 - [CatalogsFeedsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedsCreateRequest.md)
 - [CatalogsFeedsUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFeedsUpdateRequest.md)
 - [CatalogsFormat](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsFormat.md)
 - [CatalogsHotelAddress](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelAddress.md)
 - [CatalogsHotelAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelAttributes.md)
 - [CatalogsHotelAttributesAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelAttributesAllOf.md)
 - [CatalogsHotelAttributesAllOfMainImage](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelAttributesAllOfMainImage.md)
 - [CatalogsHotelBatchItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelBatchItem.md)
 - [CatalogsHotelBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelBatchRequest.md)
 - [CatalogsHotelFeed](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelFeed.md)
 - [CatalogsHotelFeedsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelFeedsCreateRequest.md)
 - [CatalogsHotelFeedsUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelFeedsUpdateRequest.md)
 - [CatalogsHotelGuestRatings](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelGuestRatings.md)
 - [CatalogsHotelItemErrorResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelItemErrorResponse.md)
 - [CatalogsHotelItemResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelItemResponse.md)
 - [CatalogsHotelItemsBatch](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelItemsBatch.md)
 - [CatalogsHotelItemsFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelItemsFilter.md)
 - [CatalogsHotelItemsPostFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelItemsPostFilter.md)
 - [CatalogsHotelListProductsByCatalogBasedFilterRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelListProductsByCatalogBasedFilterRequest.md)
 - [CatalogsHotelProduct](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProduct.md)
 - [CatalogsHotelProductGroup](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroup.md)
 - [CatalogsHotelProductGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupCreateRequest.md)
 - [CatalogsHotelProductGroupFilterKeys](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupFilterKeys.md)
 - [CatalogsHotelProductGroupFilters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupFilters.md)
 - [CatalogsHotelProductGroupFiltersAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupFiltersAllOf.md)
 - [CatalogsHotelProductGroupFiltersAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupFiltersAnyOf.md)
 - [CatalogsHotelProductGroupProductCounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupProductCounts.md)
 - [CatalogsHotelProductGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductGroupUpdateRequest.md)
 - [CatalogsHotelProductMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelProductMetadata.md)
 - [CatalogsHotelReportParameters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsHotelReportParameters.md)
 - [CatalogsItemValidationDetails](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemValidationDetails.md)
 - [CatalogsItemValidationErrors](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemValidationErrors.md)
 - [CatalogsItemValidationIssue](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemValidationIssue.md)
 - [CatalogsItemValidationIssues](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemValidationIssues.md)
 - [CatalogsItemValidationWarnings](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemValidationWarnings.md)
 - [CatalogsItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItems.md)
 - [CatalogsItemsBatch](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsBatch.md)
 - [CatalogsItemsBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsBatchRequest.md)
 - [CatalogsItemsCreateBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsCreateBatchRequest.md)
 - [CatalogsItemsDeleteBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsDeleteBatchRequest.md)
 - [CatalogsItemsDeleteDiscontinuedBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsDeleteDiscontinuedBatchRequest.md)
 - [CatalogsItemsFilters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsFilters.md)
 - [CatalogsItemsPostFilters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsPostFilters.md)
 - [CatalogsItemsRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsRequest.md)
 - [CatalogsItemsUpdateBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsUpdateBatchRequest.md)
 - [CatalogsItemsUpsertBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsItemsUpsertBatchRequest.md)
 - [CatalogsListProductsByFeedBasedFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsListProductsByFeedBasedFilter.md)
 - [CatalogsListProductsByFilterRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsListProductsByFilterRequest.md)
 - [CatalogsLocale](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsLocale.md)
 - [CatalogsProduct](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProduct.md)
 - [CatalogsProductGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupCreateRequest.md)
 - [CatalogsProductGroupCurrencyCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupCurrencyCriteria.md)
 - [CatalogsProductGroupFilterKeys](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFilterKeys.md)
 - [CatalogsProductGroupFilters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFilters.md)
 - [CatalogsProductGroupFiltersAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFiltersAllOf.md)
 - [CatalogsProductGroupFiltersAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFiltersAnyOf.md)
 - [CatalogsProductGroupFiltersRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFiltersRequest.md)
 - [CatalogsProductGroupFiltersRequestAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFiltersRequestAnyOf.md)
 - [CatalogsProductGroupFiltersRequestAnyOf1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupFiltersRequestAnyOf1.md)
 - [CatalogsProductGroupMultipleCountriesCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupMultipleCountriesCriteria.md)
 - [CatalogsProductGroupMultipleGenderCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupMultipleGenderCriteria.md)
 - [CatalogsProductGroupMultipleMediaTypesCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupMultipleMediaTypesCriteria.md)
 - [CatalogsProductGroupMultipleStringCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupMultipleStringCriteria.md)
 - [CatalogsProductGroupMultipleStringListCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupMultipleStringListCriteria.md)
 - [CatalogsProductGroupPricingCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupPricingCriteria.md)
 - [CatalogsProductGroupPricingCurrencyCriteria](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupPricingCurrencyCriteria.md)
 - [CatalogsProductGroupProductCountsVertical](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupProductCountsVertical.md)
 - [CatalogsProductGroupStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupStatus.md)
 - [CatalogsProductGroupType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupType.md)
 - [CatalogsProductGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsProductGroupUpdateRequest.md)
 - [CatalogsReport](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReport.md)
 - [CatalogsReportDistributionIssueFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportDistributionIssueFilter.md)
 - [CatalogsReportDistributionStats](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportDistributionStats.md)
 - [CatalogsReportFeedIngestionFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportFeedIngestionFilter.md)
 - [CatalogsReportFeedIngestionStats](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportFeedIngestionStats.md)
 - [CatalogsReportParameters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportParameters.md)
 - [CatalogsReportStats](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsReportStats.md)
 - [CatalogsRetailBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailBatchRequest.md)
 - [CatalogsRetailFeed](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailFeed.md)
 - [CatalogsRetailFeedsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailFeedsCreateRequest.md)
 - [CatalogsRetailFeedsUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailFeedsUpdateRequest.md)
 - [CatalogsRetailItemErrorResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailItemErrorResponse.md)
 - [CatalogsRetailItemResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailItemResponse.md)
 - [CatalogsRetailItemsBatch](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailItemsBatch.md)
 - [CatalogsRetailItemsFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailItemsFilter.md)
 - [CatalogsRetailItemsPostFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailItemsPostFilter.md)
 - [CatalogsRetailListProductsByCatalogBasedFilterRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailListProductsByCatalogBasedFilterRequest.md)
 - [CatalogsRetailProduct](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProduct.md)
 - [CatalogsRetailProductGroup](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProductGroup.md)
 - [CatalogsRetailProductGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProductGroupCreateRequest.md)
 - [CatalogsRetailProductGroupProductCounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProductGroupProductCounts.md)
 - [CatalogsRetailProductGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProductGroupUpdateRequest.md)
 - [CatalogsRetailProductMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailProductMetadata.md)
 - [CatalogsRetailReportParameters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsRetailReportParameters.md)
 - [CatalogsStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsStatus.md)
 - [CatalogsType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsType.md)
 - [CatalogsUpdatableCreativeAssetsAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpdatableCreativeAssetsAttributes.md)
 - [CatalogsUpdatableHotelAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpdatableHotelAttributes.md)
 - [CatalogsUpdateCreativeAssetsItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpdateCreativeAssetsItem.md)
 - [CatalogsUpdateHotelItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpdateHotelItem.md)
 - [CatalogsUpdateRetailItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpdateRetailItem.md)
 - [CatalogsUpsertCreativeAssetsItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpsertCreativeAssetsItem.md)
 - [CatalogsUpsertHotelItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpsertHotelItem.md)
 - [CatalogsUpsertRetailItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsUpsertRetailItem.md)
 - [CatalogsVerticalBatchRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalBatchRequest.md)
 - [CatalogsVerticalFeedsCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalFeedsCreateRequest.md)
 - [CatalogsVerticalFeedsUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalFeedsUpdateRequest.md)
 - [CatalogsVerticalProductGroup](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalProductGroup.md)
 - [CatalogsVerticalProductGroupCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalProductGroupCreateRequest.md)
 - [CatalogsVerticalProductGroupUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalProductGroupUpdateRequest.md)
 - [CatalogsVerticalsListProductsByCatalogBasedFilterRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CatalogsVerticalsListProductsByCatalogBasedFilterRequest.md)
 - [ConditionFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConditionFilter.md)
 - [ConversionApiResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionApiResponse.md)
 - [ConversionApiResponseEvents](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionApiResponseEvents.md)
 - [ConversionAttributionWindowDays](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionAttributionWindowDays.md)
 - [ConversionEventResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventResponse.md)
 - [ConversionEvents](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEvents.md)
 - [ConversionEventsCustomData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsCustomData.md)
 - [ConversionEventsCustomDataContents](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsCustomDataContents.md)
 - [ConversionEventsData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsData.md)
 - [ConversionEventsUserData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsUserData.md)
 - [ConversionEventsUserDataAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsUserDataAnyOf.md)
 - [ConversionEventsUserDataAnyOf1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsUserDataAnyOf1.md)
 - [ConversionEventsUserDataAnyOf2](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionEventsUserDataAnyOf2.md)
 - [ConversionReportAttributionType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionReportAttributionType.md)
 - [ConversionReportTimeType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionReportTimeType.md)
 - [ConversionTagCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagCommon.md)
 - [ConversionTagConfigs](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagConfigs.md)
 - [ConversionTagCreate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagCreate.md)
 - [ConversionTagListResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagListResponse.md)
 - [ConversionTagResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagResponse.md)
 - [ConversionTagType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagType.md)
 - [ConversionTagsOcpmEligibleResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ConversionTagsOcpmEligibleResponse.md)
 - [Country](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Country.md)
 - [CountryFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CountryFilter.md)
 - [CreateAssetAccessRequestBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetAccessRequestBody.md)
 - [CreateAssetAccessRequestBodyAssetRequests](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetAccessRequestBodyAssetRequests.md)
 - [CreateAssetAccessRequestErrorMessage](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetAccessRequestErrorMessage.md)
 - [CreateAssetAccessRequestResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetAccessRequestResponse.md)
 - [CreateAssetGroupBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetGroupBody.md)
 - [CreateAssetGroupResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetGroupResponse.md)
 - [CreateAssetInvitesRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetInvitesRequest.md)
 - [CreateAssetInvitesRequestItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateAssetInvitesRequestItem.md)
 - [CreateInvitesResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateInvitesResultsResponseArray.md)
 - [CreateInvitesResultsResponseArrayInvite](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateInvitesResultsResponseArrayInvite.md)
 - [CreateInvitesResultsResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateInvitesResultsResponseArrayItems.md)
 - [CreateMMMReportRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateMMMReportRequest.md)
 - [CreateMMMReportRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateMMMReportRequestAllOf.md)
 - [CreateMMMReportResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateMMMReportResponse.md)
 - [CreateMMMReportResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateMMMReportResponseData.md)
 - [CreateMembershipOrPartnershipInvitesBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreateMembershipOrPartnershipInvitesBody.md)
 - [CreativeAssetsIdFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreativeAssetsIdFilter.md)
 - [CreativeAssetsProcessingRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreativeAssetsProcessingRecord.md)
 - [CreativeAssetsVisibilityType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreativeAssetsVisibilityType.md)
 - [CreativeType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CreativeType.md)
 - [Currency](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Currency.md)
 - [CurrencyFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CurrencyFilter.md)
 - [CustomLabel0Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomLabel0Filter.md)
 - [CustomLabel1Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomLabel1Filter.md)
 - [CustomLabel2Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomLabel2Filter.md)
 - [CustomLabel3Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomLabel3Filter.md)
 - [CustomLabel4Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomLabel4Filter.md)
 - [CustomerList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerList.md)
 - [CustomerListRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListRequest.md)
 - [CustomerListUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/CustomerListUpdateRequest.md)
 - [DataOutputFormat](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DataOutputFormat.md)
 - [DataStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DataStatus.md)
 - [DeleteAssetGroupBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteAssetGroupBody.md)
 - [DeleteAssetGroupResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteAssetGroupResponse.md)
 - [DeleteAssetGroupResponseExceptions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteAssetGroupResponseExceptions.md)
 - [DeleteInvitesResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteInvitesResultsResponseArray.md)
 - [DeleteInvitesResultsResponseArrayException](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteInvitesResultsResponseArrayException.md)
 - [DeleteInvitesResultsResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteInvitesResultsResponseArrayItems.md)
 - [DeleteMemberAccessResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteMemberAccessResult.md)
 - [DeleteMemberAccessResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeleteMemberAccessResultsResponseArray.md)
 - [DeletePartnerAssetAccessBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnerAssetAccessBody.md)
 - [DeletePartnerAssetAccessBodyAccesses](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnerAssetAccessBodyAccesses.md)
 - [DeletePartnerAssetsResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnerAssetsResult.md)
 - [DeletePartnerAssetsResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnerAssetsResultsResponseArray.md)
 - [DeletePartnersRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnersRequest.md)
 - [DeletePartnersResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletePartnersResponse.md)
 - [DeletedMembersResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeletedMembersResponse.md)
 - [DeliveryMetricsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeliveryMetricsResponse.md)
 - [DeliveryMetricsResponseItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DeliveryMetricsResponseItems.md)
 - [DetailedError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/DetailedError.md)
 - [EnhancedMatchStatusType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/EnhancedMatchStatusType.md)
 - [EntityStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/EntityStatus.md)
 - [Error](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Error.md)
 - [Exception](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Exception.md)
 - [FeedFields](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/FeedFields.md)
 - [FeedFields1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/FeedFields1.md)
 - [FeedFields2](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/FeedFields2.md)
 - [FollowUserRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/FollowUserRequest.md)
 - [Gender](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Gender.md)
 - [GenderFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GenderFilter.md)
 - [GenderList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GenderList.md)
 - [GetAudiencesOrderBy](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetAudiencesOrderBy.md)
 - [GetBusinessAssetTypeResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetBusinessAssetTypeResponse.md)
 - [GetBusinessAssetsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetBusinessAssetsResponse.md)
 - [GetMMMReportResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetMMMReportResponse.md)
 - [GetMMMReportResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetMMMReportResponseData.md)
 - [GetPartnerAssetsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GetPartnerAssetsResponse.md)
 - [GoogleProductCategory0Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory0Filter.md)
 - [GoogleProductCategory1Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory1Filter.md)
 - [GoogleProductCategory2Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory2Filter.md)
 - [GoogleProductCategory3Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory3Filter.md)
 - [GoogleProductCategory4Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory4Filter.md)
 - [GoogleProductCategory5Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory5Filter.md)
 - [GoogleProductCategory6Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GoogleProductCategory6Filter.md)
 - [Granularity](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Granularity.md)
 - [GridClickType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/GridClickType.md)
 - [HotelIdFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/HotelIdFilter.md)
 - [HotelProcessingRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/HotelProcessingRecord.md)
 - [ImageDetails](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ImageDetails.md)
 - [ImageMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ImageMetadata.md)
 - [ImageMetadataImages](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ImageMetadataImages.md)
 - [InlineObject](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InlineObject.md)
 - [InlineObject1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InlineObject1.md)
 - [IntegrationLog](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLog.md)
 - [IntegrationLogClientError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogClientError.md)
 - [IntegrationLogClientRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogClientRequest.md)
 - [IntegrationLogsInvalidLogResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogsInvalidLogResponse.md)
 - [IntegrationLogsInvalidLogResponseRejectedLogs](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogsInvalidLogResponseRejectedLogs.md)
 - [IntegrationLogsRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogsRequest.md)
 - [IntegrationLogsSuccessResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationLogsSuccessResponse.md)
 - [IntegrationMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationMetadata.md)
 - [IntegrationRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationRecord.md)
 - [IntegrationRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationRequest.md)
 - [IntegrationRequestPatch](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/IntegrationRequestPatch.md)
 - [Interest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Interest.md)
 - [InviteAssetsSummary](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteAssetsSummary.md)
 - [InviteAssetsSummaryAdAccounts](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteAssetsSummaryAdAccounts.md)
 - [InviteAssetsSummaryProfiles](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteAssetsSummaryProfiles.md)
 - [InviteBusinessRoleBinding](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteBusinessRoleBinding.md)
 - [InviteExceptionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteExceptionResponse.md)
 - [InviteResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteResponse.md)
 - [InviteStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteStatus.md)
 - [InviteType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/InviteType.md)
 - [ItemAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemAttributes.md)
 - [ItemAttributesAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemAttributesAllOf.md)
 - [ItemAttributesRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemAttributesRequest.md)
 - [ItemAttributesRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemAttributesRequestAllOf.md)
 - [ItemBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemBatchRecord.md)
 - [ItemCreateBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemCreateBatchRecord.md)
 - [ItemDeleteBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemDeleteBatchRecord.md)
 - [ItemDeleteDiscontinuedBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemDeleteDiscontinuedBatchRecord.md)
 - [ItemGroupIdFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemGroupIdFilter.md)
 - [ItemIdFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemIdFilter.md)
 - [ItemProcessingRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemProcessingRecord.md)
 - [ItemProcessingStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemProcessingStatus.md)
 - [ItemResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemResponse.md)
 - [ItemResponseAnyOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemResponseAnyOf.md)
 - [ItemResponseAnyOf1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemResponseAnyOf1.md)
 - [ItemUpdateBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemUpdateBatchRecord.md)
 - [ItemUpsertBatchRecord](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemUpsertBatchRecord.md)
 - [ItemValidationEvent](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ItemValidationEvent.md)
 - [Keyword](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Keyword.md)
 - [KeywordAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordAllOf.md)
 - [KeywordError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordError.md)
 - [KeywordList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordList.md)
 - [KeywordMetrics](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordMetrics.md)
 - [KeywordMetricsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordMetricsResponse.md)
 - [KeywordUpdate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordUpdate.md)
 - [KeywordUpdateBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordUpdateBody.md)
 - [KeywordsCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsCommon.md)
 - [KeywordsMetricsArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsMetricsArrayResponse.md)
 - [KeywordsRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsRequest.md)
 - [KeywordsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/KeywordsResponse.md)
 - [L1InterestList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/L1InterestList.md)
 - [Language](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Language.md)
 - [LeadFormArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormArrayResponse.md)
 - [LeadFormArrayResponseItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormArrayResponseItems.md)
 - [LeadFormCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormCommon.md)
 - [LeadFormCommonPolicyLinks](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormCommonPolicyLinks.md)
 - [LeadFormCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormCreateRequest.md)
 - [LeadFormQuestion](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormQuestion.md)
 - [LeadFormQuestionFieldType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormQuestionFieldType.md)
 - [LeadFormQuestionType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormQuestionType.md)
 - [LeadFormResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormResponse.md)
 - [LeadFormResponseAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormResponseAllOf.md)
 - [LeadFormStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormStatus.md)
 - [LeadFormTestRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormTestRequest.md)
 - [LeadFormTestResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormTestResponse.md)
 - [LeadFormUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormUpdateRequest.md)
 - [LeadFormUpdateRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadFormUpdateRequestAllOf.md)
 - [LeadsExportCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportCreateRequest.md)
 - [LeadsExportCreateResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportCreateResponse.md)
 - [LeadsExportResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportResponseData.md)
 - [LeadsExportStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LeadsExportStatus.md)
 - [LineItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LineItem.md)
 - [LinkedBusiness](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/LinkedBusiness.md)
 - [MMMReportingColumn](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MMMReportingColumn.md)
 - [MMMReportingTargetingType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MMMReportingTargetingType.md)
 - [MatchType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MatchType.md)
 - [MatchTypeResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MatchTypeResponse.md)
 - [MaxPriceFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MaxPriceFilter.md)
 - [MediaType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaType.md)
 - [MediaTypeFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaTypeFilter.md)
 - [MediaUpload](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUpload.md)
 - [MediaUploadAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadAllOf.md)
 - [MediaUploadAllOfUploadParameters](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadAllOfUploadParameters.md)
 - [MediaUploadDetails](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadDetails.md)
 - [MediaUploadRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadRequest.md)
 - [MediaUploadStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadStatus.md)
 - [MediaUploadType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MediaUploadType.md)
 - [MemberBusinessRole](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MemberBusinessRole.md)
 - [MembersToDeleteBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MembersToDeleteBody.md)
 - [MembersToDeleteBodyMembers](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MembersToDeleteBodyMembers.md)
 - [Metrics](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Metrics.md)
 - [MetricsReportingLevel](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MetricsReportingLevel.md)
 - [MetricsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MetricsResponse.md)
 - [MinPriceFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/MinPriceFilter.md)
 - [NonNullableCatalogsCurrency](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/NonNullableCatalogsCurrency.md)
 - [NonNullableProductAvailabilityType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/NonNullableProductAvailabilityType.md)
 - [NullableCatalogsItemFieldType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/NullableCatalogsItemFieldType.md)
 - [NullableCurrency](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/NullableCurrency.md)
 - [OauthAccessTokenRequestClientCredentials](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestClientCredentials.md)
 - [OauthAccessTokenRequestClientCredentialsAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestClientCredentialsAllOf.md)
 - [OauthAccessTokenRequestCode](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestCode.md)
 - [OauthAccessTokenRequestCodeAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestCodeAllOf.md)
 - [OauthAccessTokenRequestRefresh](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestRefresh.md)
 - [OauthAccessTokenRequestRefreshAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenRequestRefreshAllOf.md)
 - [OauthAccessTokenResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponse.md)
 - [OauthAccessTokenResponseClientCredentials](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseClientCredentials.md)
 - [OauthAccessTokenResponseCode](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseCode.md)
 - [OauthAccessTokenResponseCodeAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseCodeAllOf.md)
 - [OauthAccessTokenResponseEverlastingRefresh](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseEverlastingRefresh.md)
 - [OauthAccessTokenResponseEverlastingRefreshAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseEverlastingRefreshAllOf.md)
 - [OauthAccessTokenResponseIntegrationRefresh](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseIntegrationRefresh.md)
 - [OauthAccessTokenResponseRefresh](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseRefresh.md)
 - [OauthAccessTokenResponseRefreshAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OauthAccessTokenResponseRefreshAllOf.md)
 - [ObjectiveType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ObjectiveType.md)
 - [OperationType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OperationType.md)
 - [OptimizationGoalMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OptimizationGoalMetadata.md)
 - [OptimizationGoalMetadataConversionTagV3GoalMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OptimizationGoalMetadataConversionTagV3GoalMetadata.md)
 - [OptimizationGoalMetadataConversionTagV3GoalMetadataAttributionWindows](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OptimizationGoalMetadataConversionTagV3GoalMetadataAttributionWindows.md)
 - [OptimizationGoalMetadataFrequencyGoalMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OptimizationGoalMetadataFrequencyGoalMetadata.md)
 - [OptimizationGoalMetadataScrollupGoalMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OptimizationGoalMetadataScrollupGoalMetadata.md)
 - [OrderLine](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLine.md)
 - [OrderLineAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLineAllOf.md)
 - [OrderLineError](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLineError.md)
 - [OrderLinePaidType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLinePaidType.md)
 - [OrderLineResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLineResponse.md)
 - [OrderLineSingleResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLineSingleResponse.md)
 - [OrderLineStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLineStatus.md)
 - [OrderLines](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLines.md)
 - [OrderLinesArrayResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/OrderLinesArrayResponse.md)
 - [PacingDeliveryType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PacingDeliveryType.md)
 - [Paginated](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Paginated.md)
 - [PartnerType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PartnerType.md)
 - [Permissions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Permissions.md)
 - [PermissionsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PermissionsResponse.md)
 - [PermissionsWithOwner](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PermissionsWithOwner.md)
 - [Pin](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Pin.md)
 - [PinAnalyticsMetricsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinAnalyticsMetricsResponse.md)
 - [PinAnalyticsMetricsResponseDailyMetrics](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinAnalyticsMetricsResponseDailyMetrics.md)
 - [PinAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinAnalyticsResponse.md)
 - [PinCreate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinCreate.md)
 - [PinMedia](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMedia.md)
 - [PinMediaMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaMetadata.md)
 - [PinMediaSource](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSource.md)
 - [PinMediaSourceImageBase64](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImageBase64.md)
 - [PinMediaSourceImageURL](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImageURL.md)
 - [PinMediaSourceImagesBase64](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImagesBase64.md)
 - [PinMediaSourceImagesBase64Items](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImagesBase64Items.md)
 - [PinMediaSourceImagesURL](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImagesURL.md)
 - [PinMediaSourceImagesURLItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceImagesURLItems.md)
 - [PinMediaSourcePinURL](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourcePinURL.md)
 - [PinMediaSourceVideoID](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaSourceVideoID.md)
 - [PinMediaWithImage](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImage.md)
 - [PinMediaWithImageAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImageAllOf.md)
 - [PinMediaWithImageAndVideo](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImageAndVideo.md)
 - [PinMediaWithImageAndVideoAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImageAndVideoAllOf.md)
 - [PinMediaWithImages](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImages.md)
 - [PinMediaWithImagesAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithImagesAllOf.md)
 - [PinMediaWithVideo](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithVideo.md)
 - [PinMediaWithVideoAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithVideoAllOf.md)
 - [PinMediaWithVideos](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithVideos.md)
 - [PinMediaWithVideosAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinMediaWithVideosAllOf.md)
 - [PinPromotionSummaryStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinPromotionSummaryStatus.md)
 - [PinUpdate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinUpdate.md)
 - [PinUpdateCarouselSlots](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinUpdateCarouselSlots.md)
 - [PinterestTagEventData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PinterestTagEventData.md)
 - [PlacementGroupType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PlacementGroupType.md)
 - [PlacementMultipliers](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PlacementMultipliers.md)
 - [PriceFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/PriceFilter.md)
 - [ProductAvailabilityType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductAvailabilityType.md)
 - [ProductGroupAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupAnalyticsResponse.md)
 - [ProductGroupPromotion](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotion.md)
 - [ProductGroupPromotionCreateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionCreateRequest.md)
 - [ProductGroupPromotionCreateRequestElement](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionCreateRequestElement.md)
 - [ProductGroupPromotionCreateRequestElementAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionCreateRequestElementAllOf.md)
 - [ProductGroupPromotionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionResponse.md)
 - [ProductGroupPromotionResponseElement](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionResponseElement.md)
 - [ProductGroupPromotionResponseItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionResponseItem.md)
 - [ProductGroupPromotionUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupPromotionUpdateRequest.md)
 - [ProductGroupReferenceFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupReferenceFilter.md)
 - [ProductGroupSummaryStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductGroupSummaryStatus.md)
 - [ProductType0Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductType0Filter.md)
 - [ProductType1Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductType1Filter.md)
 - [ProductType2Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductType2Filter.md)
 - [ProductType3Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductType3Filter.md)
 - [ProductType4Filter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ProductType4Filter.md)
 - [QuizPinData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/QuizPinData.md)
 - [QuizPinOption](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/QuizPinOption.md)
 - [QuizPinQuestion](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/QuizPinQuestion.md)
 - [QuizPinResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/QuizPinResult.md)
 - [RelatedTerms](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/RelatedTerms.md)
 - [RelatedTermsRelatedTermsList](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/RelatedTermsRelatedTermsList.md)
 - [ReportingColumnAsync](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/ReportingColumnAsync.md)
 - [RespondToInvitesResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/RespondToInvitesResponseArray.md)
 - [RespondToInvitesResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/RespondToInvitesResponseArrayItems.md)
 - [Role](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/Role.md)
 - [SSIOAccountAddress](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOAccountAddress.md)
 - [SSIOAccountItem](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOAccountItem.md)
 - [SSIOAccountPMPName](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOAccountPMPName.md)
 - [SSIOAccountResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOAccountResponse.md)
 - [SSIOCreateInsertionOrderRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOCreateInsertionOrderRequest.md)
 - [SSIOCreateInsertionOrderRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOCreateInsertionOrderRequestAllOf.md)
 - [SSIOCreateInsertionOrderResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOCreateInsertionOrderResponse.md)
 - [SSIOEditInsertionOrderRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOEditInsertionOrderRequest.md)
 - [SSIOEditInsertionOrderRequestAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOEditInsertionOrderRequestAllOf.md)
 - [SSIOEditInsertionOrderResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOEditInsertionOrderResponse.md)
 - [SSIOInsertionOrderCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOInsertionOrderCommon.md)
 - [SSIOInsertionOrderStatus](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOInsertionOrderStatus.md)
 - [SSIOInsertionOrderStatusResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOInsertionOrderStatusResponse.md)
 - [SSIOOrderLine](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SSIOOrderLine.md)
 - [SharedAudience](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudience.md)
 - [SharedAudience1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudience1.md)
 - [SharedAudienceAccount](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudienceAccount.md)
 - [SharedAudienceCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudienceCommon.md)
 - [SharedAudienceResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudienceResponse.md)
 - [SharedAudienceResponse1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudienceResponse1.md)
 - [SharedAudienceResponseCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SharedAudienceResponseCommon.md)
 - [SingleInterestTargetingOptionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SingleInterestTargetingOptionResponse.md)
 - [SummaryPin](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/SummaryPin.md)
 - [TargetingAdvertiserCountry](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingAdvertiserCountry.md)
 - [TargetingOptionResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingOptionResponse.md)
 - [TargetingSpec](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingSpec.md)
 - [TargetingSpecAppType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingSpecAppType.md)
 - [TargetingSpecSHOPPINGRETARGETING](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingSpecSHOPPINGRETARGETING.md)
 - [TargetingTemplateAudienceSizing](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateAudienceSizing.md)
 - [TargetingTemplateAudienceSizingReachEstimate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateAudienceSizingReachEstimate.md)
 - [TargetingTemplateCommon](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateCommon.md)
 - [TargetingTemplateCreate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateCreate.md)
 - [TargetingTemplateCreateAllOf](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateCreateAllOf.md)
 - [TargetingTemplateGetResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateGetResponseData.md)
 - [TargetingTemplateGetResponseData1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateGetResponseData1.md)
 - [TargetingTemplateKeyword](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateKeyword.md)
 - [TargetingTemplateResponseData](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateResponseData.md)
 - [TargetingTemplateResponseData1](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateResponseData1.md)
 - [TargetingTemplateUpdateRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTemplateUpdateRequest.md)
 - [TargetingTypeFilter](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TargetingTypeFilter.md)
 - [TemplateResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TemplateResponse.md)
 - [TemplateResponseDateRange](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TemplateResponseDateRange.md)
 - [TemplateResponseDateRangeAbsoluteDateRange](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TemplateResponseDateRangeAbsoluteDateRange.md)
 - [TemplateResponseDateRangeDynamicDateRange](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TemplateResponseDateRangeDynamicDateRange.md)
 - [TemplateResponseDateRangeRelativeDateRange](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TemplateResponseDateRangeRelativeDateRange.md)
 - [TermsOfService](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TermsOfService.md)
 - [TermsSuggestedResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TermsSuggestedResponse.md)
 - [TopPinsAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TopPinsAnalyticsResponse.md)
 - [TopPinsAnalyticsResponseDateAvailability](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TopPinsAnalyticsResponseDateAvailability.md)
 - [TopPinsAnalyticsResponsePins](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TopPinsAnalyticsResponsePins.md)
 - [TopVideoPinsAnalyticsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TopVideoPinsAnalyticsResponse.md)
 - [TopVideoPinsAnalyticsResponsePins](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TopVideoPinsAnalyticsResponsePins.md)
 - [TrackingUrls](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TrackingUrls.md)
 - [TrendType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TrendType.md)
 - [TrendingKeywordsResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TrendingKeywordsResponse.md)
 - [TrendingKeywordsResponseTrends](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TrendingKeywordsResponseTrends.md)
 - [TrendsSupportedRegion](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/TrendsSupportedRegion.md)
 - [UpdatableItemAttributes](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatableItemAttributes.md)
 - [UpdateAssetGroupBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateAssetGroupBody.md)
 - [UpdateAssetGroupBodyAssetGroupsToUpdate](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateAssetGroupBodyAssetGroupsToUpdate.md)
 - [UpdateAssetGroupResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateAssetGroupResponse.md)
 - [UpdateAssetGroupResponseExceptions](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateAssetGroupResponseExceptions.md)
 - [UpdateInvitesResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateInvitesResultsResponseArray.md)
 - [UpdateInvitesResultsResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateInvitesResultsResponseArrayItems.md)
 - [UpdateMaskBidOptionField](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMaskBidOptionField.md)
 - [UpdateMaskFieldType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMaskFieldType.md)
 - [UpdateMemberAssetAccessBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberAssetAccessBody.md)
 - [UpdateMemberAssetAccessBodyAccesses](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberAssetAccessBodyAccesses.md)
 - [UpdateMemberAssetsResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberAssetsResultsResponseArray.md)
 - [UpdateMemberAssetsResultsResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberAssetsResultsResponseArrayItems.md)
 - [UpdateMemberBusinessRoleBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberBusinessRoleBody.md)
 - [UpdateMemberResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberResult.md)
 - [UpdateMemberResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdateMemberResultsResponseArray.md)
 - [UpdatePartnerAssetAccessBody](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerAssetAccessBody.md)
 - [UpdatePartnerAssetAccessBodyAccesses](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerAssetAccessBodyAccesses.md)
 - [UpdatePartnerAssetsResult](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerAssetsResult.md)
 - [UpdatePartnerAssetsResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerAssetsResultsResponseArray.md)
 - [UpdatePartnerResultsResponseArray](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerResultsResponseArray.md)
 - [UpdatePartnerResultsResponseArrayItems](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UpdatePartnerResultsResponseArrayItems.md)
 - [UserBusinessRoleBinding](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserBusinessRoleBinding.md)
 - [UserFollowingFeedType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserFollowingFeedType.md)
 - [UserListOperationType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserListOperationType.md)
 - [UserListType](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserListType.md)
 - [UserSingleAssetBinding](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserSingleAssetBinding.md)
 - [UserSummary](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserSummary.md)
 - [UserWebsiteSummary](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserWebsiteSummary.md)
 - [UserWebsiteVerificationCode](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserWebsiteVerificationCode.md)
 - [UserWebsiteVerifyRequest](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UserWebsiteVerifyRequest.md)
 - [UsersForIndividualAssetResponse](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/UsersForIndividualAssetResponse.md)
 - [VideoMetadata](https://github.com/pinterest/pinterest-python-generated-api-client/blob/main/docs/VideoMetadata.md)


## Documentation For Authorization


## basic

- **Type**: HTTP basic authentication


## client_credentials

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - **ads:read**: See all of your advertising data, including ads, ad groups, campaigns etc.
 - **ads:write**: Create, update, or delete ads, ad groups, campaigns etc.
 - **billing:read**: See all of your billing data, billing profile, etc.
 - **billing:write**: Create, update, or delete billing data, billing profiles, etc.
 - **biz_access:read**: See business access data
 - **biz_access:write**: Create, update, or delete business access data
 - **boards:read**: See your public boards, including group boards you join
 - **boards:read_secret**: See your secret boards
 - **boards:write**: Create, update, or delete your public boards
 - **boards:write_secret**: Create, update, or delete your secret boards
 - **catalogs:read**: See all of your catalogs data
 - **catalogs:write**: Create, update, or delete your catalogs data
 - **pins:read**: See your public Pins
 - **pins:read_secret**: See your secret Pins
 - **pins:write**: Create, update, or delete your public Pins
 - **pins:write_secret**: Create, update, or delete your secret Pins
 - **user_accounts:read**: See your user accounts and followers
 - **user_accounts:write**: Update your user accounts and followers


## conversion_token

- **Type**: Bearer authentication


## pinterest_oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://www.pinterest.com/oauth/
- **Scopes**: 
 - **ads:read**: See all of your advertising data, including ads, ad groups, campaigns etc.
 - **ads:write**: Create, update, or delete ads, ad groups, campaigns etc.
 - **billing:read**: See all of your billing data, billing profile, etc.
 - **billing:write**: Create, update, or delete billing data, billing profiles, etc.
 - **biz_access:read**: See business access data
 - **biz_access:write**: Create, update, or delete business access data
 - **boards:read**: See your public boards, including group boards you join
 - **boards:read_secret**: See your secret boards
 - **boards:write**: Create, update, or delete your public boards
 - **boards:write_secret**: Create, update, or delete your secret boards
 - **catalogs:read**: See all of your catalogs data
 - **catalogs:write**: Create, update, or delete your catalogs data
 - **pins:read**: See your public Pins
 - **pins:read_secret**: See your secret Pins
 - **pins:write**: Create, update, or delete your public Pins
 - **pins:write_secret**: Create, update, or delete your secret Pins
 - **user_accounts:read**: See your user accounts and followers
 - **user_accounts:write**: Update your user accounts and followers


## Author

pinterest-api@pinterest.com


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in openapi_generated.pinterest_client.apis and openapi_generated.pinterest_client.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from openapi_generated.pinterest_client.api.default_api import DefaultApi`
- `from openapi_generated.pinterest_client.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import openapi_generated.pinterest_client
from openapi_generated.pinterest_client.apis import *
from openapi_generated.pinterest_client.models import *
```
