"""
    Pinterest REST API

    Pinterest's REST API  # noqa: E501

    The version of the OpenAPI document: 5.14.0
    Contact: pinterest-api@pinterest.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from openapi_generated.pinterest_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from openapi_generated.pinterest_client.exceptions import ApiAttributeError


def lazy_import():
    from openapi_generated.pinterest_client.model.conversion_events_custom_data import ConversionEventsCustomData
    from openapi_generated.pinterest_client.model.conversion_events_user_data import ConversionEventsUserData
    globals()['ConversionEventsCustomData'] = ConversionEventsCustomData
    globals()['ConversionEventsUserData'] = ConversionEventsUserData


class ConversionEventsData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'event_name': (str,),  # noqa: E501
            'action_source': (str,),  # noqa: E501
            'event_time': (int,),  # noqa: E501
            'event_id': (str,),  # noqa: E501
            'user_data': (ConversionEventsUserData,),  # noqa: E501
            'event_source_url': (str, none_type,),  # noqa: E501
            'opt_out': (bool,),  # noqa: E501
            'partner_name': (str, none_type,),  # noqa: E501
            'custom_data': (ConversionEventsCustomData,),  # noqa: E501
            'app_id': (str, none_type,),  # noqa: E501
            'app_name': (str, none_type,),  # noqa: E501
            'app_version': (str, none_type,),  # noqa: E501
            'device_brand': (str, none_type,),  # noqa: E501
            'device_carrier': (str, none_type,),  # noqa: E501
            'device_model': (str, none_type,),  # noqa: E501
            'device_type': (str, none_type,),  # noqa: E501
            'os_version': (str, none_type,),  # noqa: E501
            'wifi': (bool,),  # noqa: E501
            'language': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'event_name': 'event_name',  # noqa: E501
        'action_source': 'action_source',  # noqa: E501
        'event_time': 'event_time',  # noqa: E501
        'event_id': 'event_id',  # noqa: E501
        'user_data': 'user_data',  # noqa: E501
        'event_source_url': 'event_source_url',  # noqa: E501
        'opt_out': 'opt_out',  # noqa: E501
        'partner_name': 'partner_name',  # noqa: E501
        'custom_data': 'custom_data',  # noqa: E501
        'app_id': 'app_id',  # noqa: E501
        'app_name': 'app_name',  # noqa: E501
        'app_version': 'app_version',  # noqa: E501
        'device_brand': 'device_brand',  # noqa: E501
        'device_carrier': 'device_carrier',  # noqa: E501
        'device_model': 'device_model',  # noqa: E501
        'device_type': 'device_type',  # noqa: E501
        'os_version': 'os_version',  # noqa: E501
        'wifi': 'wifi',  # noqa: E501
        'language': 'language',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, event_name, action_source, event_time, event_id, user_data, *args, **kwargs):  # noqa: E501
        """ConversionEventsData - a model defined in OpenAPI

        Args:
            event_name (str): <p>The type of the user event. Please use the right event_name otherwise the event won't be accepted and show up correctly in reports.   <ul>   <li><code>add_to_cart</code></li>   <li><code>checkout</code></li>   <li><code>custom</code></li>   <li><code>lead</code></li>   <li><code>page_visit</code></li>   <li><code>search</code></li>   <li><code>signup</code></li>   <li><code>view_category</code></li>   <li><code>watch_video</code></li>   </ul> </p> 
            action_source (str): <p>   The source indicating where the conversion event occurred.   <ul>     <li><code>app_android</code></li>     <li><code>app_ios</code></li>     <li><code>web</code></li>     <li><code>offline</code></li>   </ul> </p> 
            event_time (int): The time when the event happened. Unix timestamp in seconds.
            event_id (str): A unique id string that identifies this event and can be used for deduping between events ingested via both the conversion API and Pinterest tracking. Without this, event's data is likely to be double counted and will cause report metric inflation. Third-party vendors make sure this field is updated on both Pinterest tag and Conversions API side before rolling out template for Conversions API.
            user_data (ConversionEventsUserData):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            event_source_url (str, none_type): URL of the web conversion event.. [optional]  # noqa: E501
            opt_out (bool): When action_source is web or offline, it defines whether the user has opted out of tracking for web conversion events. While when action_source is app_android or app_ios, it defines whether the user has enabled Limit Ad Tracking on their iOS device, or opted out of Ads Personalization on their Android device.. [optional]  # noqa: E501
            partner_name (str, none_type): The third party partner name responsible to send the event to Conversions API on behalf of the advertiser. The naming convention is \"ss-partnername\" lowercase. E.g ‘ss-shopify’. [optional]  # noqa: E501
            custom_data (ConversionEventsCustomData): [optional]  # noqa: E501
            app_id (str, none_type): The app store app ID.. [optional]  # noqa: E501
            app_name (str, none_type): Name of the app.. [optional]  # noqa: E501
            app_version (str, none_type): Version of the app.. [optional]  # noqa: E501
            device_brand (str, none_type): Brand of the user device.. [optional]  # noqa: E501
            device_carrier (str, none_type): User device's mobile carrier.. [optional]  # noqa: E501
            device_model (str, none_type): Model of the user device.. [optional]  # noqa: E501
            device_type (str, none_type): Type of the user device.. [optional]  # noqa: E501
            os_version (str, none_type): Version of the device operating system.. [optional]  # noqa: E501
            wifi (bool): Whether the event occurred when the user device was connected to wifi.. [optional]  # noqa: E501
            language (str, none_type): Two-character ISO-639-1 language code indicating the user's language.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.event_name = event_name
        self.action_source = action_source
        self.event_time = event_time
        self.event_id = event_id
        self.user_data = user_data
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, event_name, action_source, event_time, event_id, user_data, *args, **kwargs):  # noqa: E501
        """ConversionEventsData - a model defined in OpenAPI

        Args:
            event_name (str): <p>The type of the user event. Please use the right event_name otherwise the event won't be accepted and show up correctly in reports.   <ul>   <li><code>add_to_cart</code></li>   <li><code>checkout</code></li>   <li><code>custom</code></li>   <li><code>lead</code></li>   <li><code>page_visit</code></li>   <li><code>search</code></li>   <li><code>signup</code></li>   <li><code>view_category</code></li>   <li><code>watch_video</code></li>   </ul> </p> 
            action_source (str): <p>   The source indicating where the conversion event occurred.   <ul>     <li><code>app_android</code></li>     <li><code>app_ios</code></li>     <li><code>web</code></li>     <li><code>offline</code></li>   </ul> </p> 
            event_time (int): The time when the event happened. Unix timestamp in seconds.
            event_id (str): A unique id string that identifies this event and can be used for deduping between events ingested via both the conversion API and Pinterest tracking. Without this, event's data is likely to be double counted and will cause report metric inflation. Third-party vendors make sure this field is updated on both Pinterest tag and Conversions API side before rolling out template for Conversions API.
            user_data (ConversionEventsUserData):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            event_source_url (str, none_type): URL of the web conversion event.. [optional]  # noqa: E501
            opt_out (bool): When action_source is web or offline, it defines whether the user has opted out of tracking for web conversion events. While when action_source is app_android or app_ios, it defines whether the user has enabled Limit Ad Tracking on their iOS device, or opted out of Ads Personalization on their Android device.. [optional]  # noqa: E501
            partner_name (str, none_type): The third party partner name responsible to send the event to Conversions API on behalf of the advertiser. The naming convention is \"ss-partnername\" lowercase. E.g ‘ss-shopify’. [optional]  # noqa: E501
            custom_data (ConversionEventsCustomData): [optional]  # noqa: E501
            app_id (str, none_type): The app store app ID.. [optional]  # noqa: E501
            app_name (str, none_type): Name of the app.. [optional]  # noqa: E501
            app_version (str, none_type): Version of the app.. [optional]  # noqa: E501
            device_brand (str, none_type): Brand of the user device.. [optional]  # noqa: E501
            device_carrier (str, none_type): User device's mobile carrier.. [optional]  # noqa: E501
            device_model (str, none_type): Model of the user device.. [optional]  # noqa: E501
            device_type (str, none_type): Type of the user device.. [optional]  # noqa: E501
            os_version (str, none_type): Version of the device operating system.. [optional]  # noqa: E501
            wifi (bool): Whether the event occurred when the user device was connected to wifi.. [optional]  # noqa: E501
            language (str, none_type): Two-character ISO-639-1 language code indicating the user's language.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.event_name = event_name
        self.action_source = action_source
        self.event_time = event_time
        self.event_id = event_id
        self.user_data = user_data
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
