"""
    Pinterest REST API

    Pinterest's REST API  # noqa: E501

    The version of the OpenAPI document: 5.14.0
    Contact: pinterest-api@pinterest.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from openapi_generated.pinterest_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from openapi_generated.pinterest_client.exceptions import ApiAttributeError


def lazy_import():
    from openapi_generated.pinterest_client.model.integration_log_client_error import IntegrationLogClientError
    from openapi_generated.pinterest_client.model.integration_log_client_request import IntegrationLogClientRequest
    globals()['IntegrationLogClientError'] = IntegrationLogClientError
    globals()['IntegrationLogClientRequest'] = IntegrationLogClientRequest


class IntegrationLog(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('event_type',): {
            'APP': "APP",
            'API': "API",
        },
        ('log_level',): {
            'INFO': "INFO",
            'WARN': "WARN",
            'ERROR': "ERROR",
        },
    }

    validations = {
        ('external_business_id',): {
            'max_length': 2048,
        },
        ('advertiser_id',): {
            'max_length': 128,
        },
        ('merchant_id',): {
            'max_length': 128,
        },
        ('tag_id',): {
            'max_length': 128,
        },
        ('feed_profile_id',): {
            'max_length': 128,
        },
        ('message',): {
            'max_length': 2048,
        },
        ('app_version_number',): {
            'max_length': 20,
        },
        ('platform_version_number',): {
            'max_length': 20,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'client_timestamp': (int,),  # noqa: E501
            'event_type': (str,),  # noqa: E501
            'log_level': (str,),  # noqa: E501
            'external_business_id': (str, none_type,),  # noqa: E501
            'advertiser_id': (str, none_type,),  # noqa: E501
            'merchant_id': (str, none_type,),  # noqa: E501
            'tag_id': (str, none_type,),  # noqa: E501
            'feed_profile_id': (str, none_type,),  # noqa: E501
            'message': (str,),  # noqa: E501
            'app_version_number': (str,),  # noqa: E501
            'platform_version_number': (str,),  # noqa: E501
            'error': (IntegrationLogClientError,),  # noqa: E501
            'request': (IntegrationLogClientRequest,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'client_timestamp': 'client_timestamp',  # noqa: E501
        'event_type': 'event_type',  # noqa: E501
        'log_level': 'log_level',  # noqa: E501
        'external_business_id': 'external_business_id',  # noqa: E501
        'advertiser_id': 'advertiser_id',  # noqa: E501
        'merchant_id': 'merchant_id',  # noqa: E501
        'tag_id': 'tag_id',  # noqa: E501
        'feed_profile_id': 'feed_profile_id',  # noqa: E501
        'message': 'message',  # noqa: E501
        'app_version_number': 'app_version_number',  # noqa: E501
        'platform_version_number': 'platform_version_number',  # noqa: E501
        'error': 'error',  # noqa: E501
        'request': 'request',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, client_timestamp, event_type, log_level, *args, **kwargs):  # noqa: E501
        """IntegrationLog - a model defined in OpenAPI

        Args:
            client_timestamp (int): Timestamp in milliseconds of when the log was executed at the client.
            event_type (str): Log event type
            log_level (str): Log level type

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            external_business_id (str, none_type): [optional]  # noqa: E501
            advertiser_id (str, none_type): [optional]  # noqa: E501
            merchant_id (str, none_type): [optional]  # noqa: E501
            tag_id (str, none_type): [optional]  # noqa: E501
            feed_profile_id (str, none_type): [optional]  # noqa: E501
            message (str): Explanation of the event that occured.. [optional]  # noqa: E501
            app_version_number (str): Version number of the integration application.. [optional]  # noqa: E501
            platform_version_number (str): Version number of the platform the integration application is running on.. [optional]  # noqa: E501
            error (IntegrationLogClientError): [optional]  # noqa: E501
            request (IntegrationLogClientRequest): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.client_timestamp = client_timestamp
        self.event_type = event_type
        self.log_level = log_level
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, client_timestamp, event_type, log_level, *args, **kwargs):  # noqa: E501
        """IntegrationLog - a model defined in OpenAPI

        Args:
            client_timestamp (int): Timestamp in milliseconds of when the log was executed at the client.
            event_type (str): Log event type
            log_level (str): Log level type

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            external_business_id (str, none_type): [optional]  # noqa: E501
            advertiser_id (str, none_type): [optional]  # noqa: E501
            merchant_id (str, none_type): [optional]  # noqa: E501
            tag_id (str, none_type): [optional]  # noqa: E501
            feed_profile_id (str, none_type): [optional]  # noqa: E501
            message (str): Explanation of the event that occured.. [optional]  # noqa: E501
            app_version_number (str): Version number of the integration application.. [optional]  # noqa: E501
            platform_version_number (str): Version number of the platform the integration application is running on.. [optional]  # noqa: E501
            error (IntegrationLogClientError): [optional]  # noqa: E501
            request (IntegrationLogClientRequest): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.client_timestamp = client_timestamp
        self.event_type = event_type
        self.log_level = log_level
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
