"""
    Pinterest REST API

    Pinterest's REST API  # noqa: E501

    The version of the OpenAPI document: 5.14.0
    Contact: pinterest-api@pinterest.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from openapi_generated.pinterest_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from openapi_generated.pinterest_client.exceptions import ApiAttributeError


def lazy_import():
    from openapi_generated.pinterest_client.model.currency import Currency
    from openapi_generated.pinterest_client.model.ssio_create_insertion_order_request_all_of import SSIOCreateInsertionOrderRequestAllOf
    from openapi_generated.pinterest_client.model.ssio_insertion_order_common import SSIOInsertionOrderCommon
    globals()['Currency'] = Currency
    globals()['SSIOCreateInsertionOrderRequestAllOf'] = SSIOCreateInsertionOrderRequestAllOf
    globals()['SSIOInsertionOrderCommon'] = SSIOInsertionOrderCommon


class SSIOCreateInsertionOrderRequest(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('order_line_type',): {
            'BUDGET': "BUDGET",
            'PERPETUALS': "PERPETUALS",
        },
    }

    validations = {
        ('start_date',): {
            'regex': {
                'pattern': r'^(\d{4})-(\d{2})-(\d{2})$',  # noqa: E501
            },
        },
        ('end_date',): {
            'regex': {
                'pattern': r'^(\d{4})-(\d{2})-(\d{2})$',  # noqa: E501
            },
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'start_date': (str,),  # noqa: E501
            'po_number': (str,),  # noqa: E501
            'billing_contact_firstname': (str,),  # noqa: E501
            'billing_contact_lastname': (str,),  # noqa: E501
            'billing_contact_email': (str,),  # noqa: E501
            'media_contact_firstname': (str,),  # noqa: E501
            'media_contact_lastname': (str,),  # noqa: E501
            'media_contact_email': (str,),  # noqa: E501
            'pmp_id': (str,),  # noqa: E501
            'order_name': (str,),  # noqa: E501
            'order_line_type': (str,),  # noqa: E501
            'accepted_terms_id': (str,),  # noqa: E501
            'billto_company_id': (str,),  # noqa: E501
            'billto_business_address_id': (str,),  # noqa: E501
            'billto_billing_address_id': (str,),  # noqa: E501
            'currency_info': (Currency,),  # noqa: E501
            'end_date': (str,),  # noqa: E501
            'budget_amount': (float,),  # noqa: E501
            'agency_link': (str,),  # noqa: E501
            'user_email': (str,),  # noqa: E501
            'accepted_terms_time': (int,),  # noqa: E501
            'estimated_monthly_spend': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'start_date': 'start_date',  # noqa: E501
        'po_number': 'po_number',  # noqa: E501
        'billing_contact_firstname': 'billing_contact_firstname',  # noqa: E501
        'billing_contact_lastname': 'billing_contact_lastname',  # noqa: E501
        'billing_contact_email': 'billing_contact_email',  # noqa: E501
        'media_contact_firstname': 'media_contact_firstname',  # noqa: E501
        'media_contact_lastname': 'media_contact_lastname',  # noqa: E501
        'media_contact_email': 'media_contact_email',  # noqa: E501
        'pmp_id': 'pmp_id',  # noqa: E501
        'order_name': 'order_name',  # noqa: E501
        'order_line_type': 'order_line_type',  # noqa: E501
        'accepted_terms_id': 'accepted_terms_id',  # noqa: E501
        'billto_company_id': 'billto_company_id',  # noqa: E501
        'billto_business_address_id': 'billto_business_address_id',  # noqa: E501
        'billto_billing_address_id': 'billto_billing_address_id',  # noqa: E501
        'currency_info': 'currency_info',  # noqa: E501
        'end_date': 'end_date',  # noqa: E501
        'budget_amount': 'budget_amount',  # noqa: E501
        'agency_link': 'agency_link',  # noqa: E501
        'user_email': 'user_email',  # noqa: E501
        'accepted_terms_time': 'accepted_terms_time',  # noqa: E501
        'estimated_monthly_spend': 'estimated_monthly_spend',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """SSIOCreateInsertionOrderRequest - a model defined in OpenAPI

        Keyword Args:
            start_date (str): Starting date of time period. Format: YYYY-MM-DD
            po_number (str): The po number
            billing_contact_firstname (str): The billing contact first name
            billing_contact_lastname (str): The billing contact last name
            billing_contact_email (str): The billing contact email
            media_contact_firstname (str): The media contact first name
            media_contact_lastname (str): The media contact last name
            media_contact_email (str): The media contact email
            pmp_id (str): The pmp id
            order_name (str): The order name
            order_line_type (str): Type can be Budget or Perpetual
            accepted_terms_id (str): The SFDC id for the terms
            billto_company_id (str): The bill-to company id
            billto_business_address_id (str): The bill-to business address id
            billto_billing_address_id (str): The bill-to billing address id
            currency_info (Currency):
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            end_date (str): End date of time period. Format: YYYY-MM-DD. [optional]  # noqa: E501
            budget_amount (float): If Budget order line, the budget amount.. [optional]  # noqa: E501
            agency_link (str): URL link for agency. [optional]  # noqa: E501
            user_email (str): The email of user submitting the insertion order. [optional]  # noqa: E501
            accepted_terms_time (int): The UTC timestamp (to the nearest sec) of when terms were accepted. [optional]  # noqa: E501
            estimated_monthly_spend (float): If Ongoing (perpetual) order line, the estimated monthly spend. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SSIOCreateInsertionOrderRequest - a model defined in OpenAPI

        Keyword Args:
            start_date (str): Starting date of time period. Format: YYYY-MM-DD
            po_number (str): The po number
            billing_contact_firstname (str): The billing contact first name
            billing_contact_lastname (str): The billing contact last name
            billing_contact_email (str): The billing contact email
            media_contact_firstname (str): The media contact first name
            media_contact_lastname (str): The media contact last name
            media_contact_email (str): The media contact email
            pmp_id (str): The pmp id
            order_name (str): The order name
            order_line_type (str): Type can be Budget or Perpetual
            accepted_terms_id (str): The SFDC id for the terms
            billto_company_id (str): The bill-to company id
            billto_business_address_id (str): The bill-to business address id
            billto_billing_address_id (str): The bill-to billing address id
            currency_info (Currency):
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            end_date (str): End date of time period. Format: YYYY-MM-DD. [optional]  # noqa: E501
            budget_amount (float): If Budget order line, the budget amount.. [optional]  # noqa: E501
            agency_link (str): URL link for agency. [optional]  # noqa: E501
            user_email (str): The email of user submitting the insertion order. [optional]  # noqa: E501
            accepted_terms_time (int): The UTC timestamp (to the nearest sec) of when terms were accepted. [optional]  # noqa: E501
            estimated_monthly_spend (float): If Ongoing (perpetual) order line, the estimated monthly spend. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [

          ],
          'oneOf': [
          ],
        }
