"""
    Pinterest REST API

    Pinterest's REST API  # noqa: E501

    The version of the OpenAPI document: 5.14.0
    Contact: pinterest-api@pinterest.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from openapi_generated.pinterest_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from openapi_generated.pinterest_client.exceptions import ApiAttributeError


def lazy_import():
    from openapi_generated.pinterest_client.model.currency import Currency
    globals()['Currency'] = Currency


class SSIOCreateInsertionOrderRequestAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('order_line_type',): {
            'BUDGET': "BUDGET",
            'PERPETUALS': "PERPETUALS",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'pmp_id': (str,),  # noqa: E501
            'order_name': (str,),  # noqa: E501
            'order_line_type': (str,),  # noqa: E501
            'accepted_terms_id': (str,),  # noqa: E501
            'billto_company_id': (str,),  # noqa: E501
            'billto_business_address_id': (str,),  # noqa: E501
            'billto_billing_address_id': (str,),  # noqa: E501
            'currency_info': (Currency,),  # noqa: E501
            'accepted_terms_time': (int,),  # noqa: E501
            'estimated_monthly_spend': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'pmp_id': 'pmp_id',  # noqa: E501
        'order_name': 'order_name',  # noqa: E501
        'order_line_type': 'order_line_type',  # noqa: E501
        'accepted_terms_id': 'accepted_terms_id',  # noqa: E501
        'billto_company_id': 'billto_company_id',  # noqa: E501
        'billto_business_address_id': 'billto_business_address_id',  # noqa: E501
        'billto_billing_address_id': 'billto_billing_address_id',  # noqa: E501
        'currency_info': 'currency_info',  # noqa: E501
        'accepted_terms_time': 'accepted_terms_time',  # noqa: E501
        'estimated_monthly_spend': 'estimated_monthly_spend',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, pmp_id, order_name, order_line_type, accepted_terms_id, billto_company_id, billto_business_address_id, billto_billing_address_id, currency_info, *args, **kwargs):  # noqa: E501
        """SSIOCreateInsertionOrderRequestAllOf - a model defined in OpenAPI

        Args:
            pmp_id (str): The pmp id
            order_name (str): The order name
            order_line_type (str): Type can be Budget or Perpetual
            accepted_terms_id (str): The SFDC id for the terms
            billto_company_id (str): The bill-to company id
            billto_business_address_id (str): The bill-to business address id
            billto_billing_address_id (str): The bill-to billing address id
            currency_info (Currency):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accepted_terms_time (int): The UTC timestamp (to the nearest sec) of when terms were accepted. [optional]  # noqa: E501
            estimated_monthly_spend (float): If Ongoing (perpetual) order line, the estimated monthly spend. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.pmp_id = pmp_id
        self.order_name = order_name
        self.order_line_type = order_line_type
        self.accepted_terms_id = accepted_terms_id
        self.billto_company_id = billto_company_id
        self.billto_business_address_id = billto_business_address_id
        self.billto_billing_address_id = billto_billing_address_id
        self.currency_info = currency_info
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, pmp_id, order_name, order_line_type, accepted_terms_id, billto_company_id, billto_business_address_id, billto_billing_address_id, currency_info, *args, **kwargs):  # noqa: E501
        """SSIOCreateInsertionOrderRequestAllOf - a model defined in OpenAPI

        Args:
            pmp_id (str): The pmp id
            order_name (str): The order name
            order_line_type (str): Type can be Budget or Perpetual
            accepted_terms_id (str): The SFDC id for the terms
            billto_company_id (str): The bill-to company id
            billto_business_address_id (str): The bill-to business address id
            billto_billing_address_id (str): The bill-to billing address id
            currency_info (Currency):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            accepted_terms_time (int): The UTC timestamp (to the nearest sec) of when terms were accepted. [optional]  # noqa: E501
            estimated_monthly_spend (float): If Ongoing (perpetual) order line, the estimated monthly spend. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.pmp_id = pmp_id
        self.order_name = order_name
        self.order_line_type = order_line_type
        self.accepted_terms_id = accepted_terms_id
        self.billto_company_id = billto_company_id
        self.billto_business_address_id = billto_business_address_id
        self.billto_billing_address_id = billto_billing_address_id
        self.currency_info = currency_info
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
